﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WeroSoft.Samples
{
    /// <summary>
    /// Repräsentiert ein Ereignisargument für die Benachrichtigung einer Datenveränderung in einer Messung.
    /// </summary>
    public class CwlbModelChangedEventArgs : EventArgs
    {
        /// <summary>
        /// Liefert den Name des Messfalles, zudemdie Daten gehören.
        /// </summary>
        public string MeasurementCase { get; private set; }

        /// <summary>
        /// Liefert das Messdetail.
        /// </summary>
        public CwlbMeasurementDetail Detail { get; private set; }

        /// <summary>
        /// Intialiert eine neue Instanz der Klasse CwlbModelChangedEventArgs.
        /// </summary>
        /// <param name="strName">Name des Messfalls für den das gemeldete Element gilt.</param>
        /// <param name="objDetail">Messdetails die benachrichtigt werden sollen.</param>
        public CwlbModelChangedEventArgs(string strName, CwlbMeasurementDetail objDetail)
        {
            // TODO: Complete member initialization
            MeasurementCase = strName;
            Detail = objDetail;
        }
    }
}
