﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;

namespace WeroSoft.Samples
{
    /// <summary>
    /// Definiert einen Fall für eine Messung.
    /// </summary>
    public class CwlbMeasurementCase
    {
        /// <summary>
        /// Liefert oder definiert den Namen des Messfalles.
        /// </summary>
        public string Name { get; set; }

        /// <summary>
        /// Liefert die Liste der Messreihen für den Messfall.
        /// </summary>
        public ObservableCollection<CwlbMeasurementDetail> Measurement { get; private set; }

        /// <summary>
        /// Liefert oder definiert die Anzahl der serverseitigen Instanzen.
        /// </summary>
        public int ServersideInstanceCount { get; set; }

        /// <summary>
        /// Instanziert eine neue Instanz der Klasse CwlbMeasurementCase.
        /// </summary>
        /// <param name="strName">Name des Testfalles.</param>
        public CwlbMeasurementCase(string strName)
        {
            Name = strName;
            Measurement = new ObservableCollection<CwlbMeasurementDetail>();
        }
    }
}
