﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WeroSoft.Samples
{
    /// <summary>
    /// Zeigt Details einer Messung.
    /// </summary>
    public class CwlbDetailView : CwlbViewBase
    {
        /// <summary>
        /// Liefert das Messdetail das hinter der Anzeige steckt.
        /// </summary>
        public CwlbMeasurementDetail Detail { get; set; }

        /// <summary>
        /// Liefert die Datengrösse für die die Messung erstellt wurde.
        /// </summary>
        public int DataLength
        {
            get { return Detail.DataLength; }
        }

        /// <summary>
        /// Liefert die durchschnittlich gemessene Zeit der Messreihe.
        /// </summary>
        public TimeSpan TimeSpanAvarage
        {
            get { return Detail.TimeSpanAvarage; }
        }

        /// <summary>
        /// Liefert das erste Element der Messreihe.
        /// </summary>
        public TimeSpan TimeSpanFirst
        {
            get { return Detail.TimeSpanFirst; }
        }

        /// <summary>
        /// Liefert den minimalen Wert der Messreihe.
        /// </summary>
        public TimeSpan TimeSpanMin
        {
            get { return Detail.TimeSpanMin; }
        }

        /// <summary>
        /// Liefert den maximalen Wert der Messreihe.
        /// </summary>
        public TimeSpan TimeSpanMax
        {
            get { return Detail.TimeSpanMax; }
        }

        /// <summary>
        /// Initialisiert ein neues Objekt der Klasse CwlbDetailView.
        /// </summary>
        /// <param name="objDetail">Messreihe, die hinter dem Element steht.</param>
        public CwlbDetailView(CwlbMeasurementDetail objDetail)
        {
            Detail = objDetail;
            OnPropertyChanged("DataLength");
            OnPropertyChanged("TimeSpanAvarage");
            OnPropertyChanged("TimeSpanFirst");
            OnPropertyChanged("TimeSpanMin");
            OnPropertyChanged("TimeSpanMax");
        }
    }
}
