﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace WeroSoft.Samples
{
    /// <summary>
    /// Repräsentiert die Basisklasse für Views.
    /// </summary>
    public abstract class CwlbViewBase : INotifyPropertyChanged
    {
        /// <summary>
        /// Definiert das Ereignis für die Benachrichtigung von Daten.
        /// </summary>
        public event PropertyChangedEventHandler PropertyChanged = delegate { };

        /// <summary>
        /// Löst eine Benachrichtigung einer Datenänderung aus.
        /// </summary>
        /// <param name="strPropertyName">Name der Eigenschaft dieverändert wurde.</param>
        protected void OnPropertyChanged(string strPropertyName)
        {
            PropertyChanged(this, new PropertyChangedEventArgs(strPropertyName));
        }
    }
}
