﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;

namespace WeroSoft.Samples
{
    /// <summary>
    /// Definiert die Schnittstelle für den Testserver.
    /// </summary>
    [ServiceContract]
    public interface IwlbPerformanceService
    {
        /// <summary>
        /// Modifiziert die Testdaten.
        /// </summary>
        /// <param name="objData"></param>
        /// <returns></returns>
        [OperationContract]
        CwlbDemoData Modify(CwlbDemoData objData);

        /// <summary>
        /// Gets the amount of instances created in the domain.
        /// </summary>
        /// <returns>Count of test instances within the domain.</returns>
        [OperationContract]
        int GetInstanceCounter();

        /// <summary>
        /// Resets the instance counter in the domain.
        /// </summary>
        [OperationContract]
        void ResetInstanceCounter();

        /// <summary>
        /// Definiert eine anwendungsspezifische Ping-Methode.
        /// </summary>
        /// <returns>Liefert den Namen der Maschine auf der der Serverprozess läuft.</returns>
        [OperationContract]
        string Ping();
    }
}
