﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WeroSoft.Samples.Data;
using System.ServiceModel;

namespace WeroSoft.Samples
{
    /// <summary>
    /// Implementiert den Webdienst.
    /// </summary>
    public class CwlbDemoWebService : IwlbDemoWebService
    {
        /// <summary>
        /// Liefert Demodaten.
        /// </summary>
        /// <param name="objDemoData">Demodaten, die als Eingabedaten verwendet werden.</param>
        /// <param name="iParam">Testparameter des Typs integer.</param>
        /// <param name="strParam">Testparameter des Typs String.</param>
        /// <returns>Generiertes Array mit den Testdaten,.</returns>
        public CwlbDemoData[] GetDemoData(CwlbDemoData objDemoData, int iParam, string strParam)
        {
            if (iParam < 1)
            {
                CwlbFault objFault = new CwlbFault();
                objFault.Status = EwlbWorkerStatus.Ended;
                objFault.Message = "Die Anzahl der angeforderten Elemente darf nicht kleiner als 1 sein.";
                objFault.Created = DateTime.UtcNow;
                throw new FaultException<CwlbFault>(objFault, new FaultReason("Parameterprüfung"), new FaultCode("AA2356"));
            }

            List<CwlbDemoData> cobjData = new List<CwlbDemoData>();
            for (int iCount = 0; iCount < iParam; iCount++)
            {
                CwlbDemoData objData = new CwlbDemoData();
                objData.IntegerValue = iCount;
                objData.StringValue = strParam;
                objData.Status = objDemoData.Status;
                objData.DateTimeValue = objDemoData.DateTimeValue + TimeSpan.FromDays(100 * iCount);
                cobjData.Add(objData);
            }
            return cobjData.ToArray();
        }
    }
}
