﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace WeroSoft.Samples
{
    /// <summary>
    /// Definiert die Daten, die zwischen Server und Client ausgetauscht werden.
    /// </summary>
    [DataContract(Namespace = "http://WeroSoft.net/Samples/LearningWcf")]
    public class CwlbDemoData
    {
        /// <summary>
        /// Liefert oder definiert einen Integerwert.
        /// </summary>
        [DataMember]
        public int IntegerValue { get; set; }

        /// <summary>
        /// Liefert oder definiert eine Zeichenfolge.
        /// </summary>
        [DataMember]
        public string StringValue { get; set; }

        /// <summary>
        /// Liefert oder definiert einen Datumswert.
        /// </summary>
        [DataMember]
        public DateTime DateTimeValue { get; set; }

        /// <summary>
        /// Liefert den Inhalt der Klasse.
        /// </summary>
        /// <returns>Text mit den Daten in der Folge IntegerValue, DateTimeValue, StringValue</returns>
        public override string ToString()
        {
            return string.Format("{0,5}. {1} - {2}",
                IntegerValue, DateTimeValue.ToShortDateString(), StringValue);
        }
    }
}
