﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace WeroSoft.Samples
{
    /// <summary>
    /// Definiert ein Fehlerdetail im Fall des Auftretens eines Fehlers auf der Serverseite.
    /// </summary>
    [DataContract(Namespace = "http://WeroSoft.net/Samples/LearningWcf")]
    public class CwlbFault
    {
        /// <summary>
        /// Liefert oder definiert einen Detailfehlercode.
        /// </summary>
        [DataMember]
        public int Code { get; set; }

        /// <summary>
        /// Liefert oder definiert einen detaillierten Text zur Fehlersituation.
        /// </summary>
        [DataMember]
        public string Message { get; set; }

        /// <summary>
        /// Liefert oder definiert den Zeitpunkt der Erzeugung des Fehlers.
        /// </summary>
        /// <remarks>
        /// Diese Eigenschaft dient lediglich der Demonstration der Allgemeingültigkeit und ist nicht zwingend von der WCF oder SOAP vorgeschrieben.
        /// </remarks>
        [DataMember]
        public DateTime Created { get; private set; }

        /// <summary>
        /// Initialisiert eine neue Instanz des Typs CwlbFault.
        /// </summary>
        /// <remarks>
        /// Diese Eigenschaft dient lediglich der Demonstration der Allgemeingültigkeit und ist nicht zwingend von der WCF oder SOAP vorgeschrieben.
        /// </remarks>
        public CwlbFault()
        {
            Created = DateTime.UtcNow;
        }
    }
}
