﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace WeroSoft.Samples
{
    /// <summary>
    /// Definiert die Daten, die zwischen Server und Client ausgetauscht werden.
    /// </summary>
    [DataContract(Namespace = "http://WeroSoft.net/Samples/Data", Name="DemoData")]
    public class CwlbDemoData
    {
        /// <summary>
        /// Definiert die Identität des Objekts.
        /// </summary>
        [DataMember(Name="Id", IsRequired=true, Order=1)]
        private Guid _id;

        /// <summary>
        /// Liefert die Identität des Objekts.
        /// </summary>
        public Guid Id { get { return _id; } }

        /// <summary>
        /// Liefert oder definiert eine Zeichenfolge.
        /// </summary>
        [DataMember(Order=2)]
        public string StringValue { get; set; }

        /// <summary>
        /// Liefert oder definiert einen Datumswert.
        /// </summary>
        [DataMember(Order = 3)]
        public DateTime DateTimeValue { get; set; }

        /// <summary>
        /// Liefert oder definiert einen Aufzählungswert.
        /// </summary>
        [DataMember]
        public EwlbDemoEnum EnumValue { get; set; }

        [DataMember]
        public CwlbEmbeddedData EmbeddedData { get; set; }

        /// <summary>
        /// Initialisiert eine neue Instanz des Typs CwlbDemoData.
        /// </summary>
        public CwlbDemoData()
        {
            _id = Guid.NewGuid();
        }

        /// <summary>
        /// Liefert den Inhalt des Objekts.
        /// </summary>
        /// <returns>Text mit den Daten in der Folge Identität, DateTimeValue, StringValue</returns>
        public override string ToString()
        {
            return string.Format("{0} -> {1} - {2}",
                Id, DateTimeValue.ToShortDateString(), StringValue);
        }
    }
}
