﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;

namespace WeroSoft.Samples
{
    [MessageContract(WrapperName="MessageData", WrapperNamespace="http://WeroSoft.net/Samples" )]
    public class CwlbMessageData
    {
        /// <summary>
        /// Liefert die Identität des Objekts.
        /// </summary>
        [MessageHeader(Name = "ID", Namespace = "http://WeroSoft.net/Samples/Details", Actor = "http://WeroSoft.net/Samples/DoSomething", MustUnderstand = true)]
        public Guid Id { get; set; }

        [MessageHeaderArray(Namespace = "http://WeroSoft.net/Samples/Details")]
        public string[] Data { get; set; }

        [MessageProperty(Name="LocalProperty")]
        public string StringProperty { get; set; }

        /// <summary>
        /// Liefert oder definiert eine Zeichenfolge.
        /// </summary>
        [MessageBodyMember(Name = "StringData", Namespace = "http://WeroSoft.net/Samples/Details", Order = 1)]
        public string StringValue { get; set; }

        /// <summary>
        /// Liefert oder definiert einen Datumswert.
        /// </summary>
        [MessageBodyMember]
        public DateTime DateTimeValue { get; set; }

        /// <summary>
        /// Liefert oder definiert einen Aufzählungswert.
        /// </summary>
        [MessageBodyMember]
        public EwlbDemoEnum EnumValue { get; set; }

        public CwlbMessageData()
        {
            Data = new string[] { "ABC", "DEF", "GHI" };
        }
    }
}
