﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WeroSoft.Samples
{
    /// <summary>
    /// Implementiert den Organisationsdienst.
    /// </summary>
    public class CwlbOrganizationManager : IwlbOrganizationManager 
    {
        /// <summary>
        /// Liefert eine Organisationsstruktur.
        /// </summary>
        /// <param name="strCompanyId">Identifikation des zu liefernden Strukturelements.</param>
        /// <returns>Eine Struktur einer Organisation.</returns>
        public CwlbCompany GetOrganizationStructure(string strCompanyId)
        {
            // Daten fest codiert zusammenstellen und ausliefern
            CwlbCompany objCompany = new CwlbCompany { Name = "WCF Company", Id = Guid.NewGuid().ToString() };
            objCompany.CEO = new CwlbPerson { Name = "Master", Id = Guid.NewGuid().ToString() };
            objCompany.CFO = new CwlbPerson { Name = "Monait", Id = Guid.NewGuid().ToString() };
            objCompany.Division = new CwlbDivision { Name = "Verträge", Id = Guid.NewGuid().ToString() };
            objCompany.Division.Manager = new CwlbPerson { Name = "Dolder", Id = Guid.NewGuid().ToString() };
            objCompany.Division.Division = new CwlbDivision { Name = "Datenverträge", Id = Guid.NewGuid().ToString() };
            objCompany.Division.Division.Manager = new CwlbPerson { Name = "Rosen", Id = Guid.NewGuid().ToString() };
            return objCompany;
        }
    }
}
