﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel.Channels;
using System.ServiceModel;
using System.Threading;

namespace WeroSoft.Samples
{
    /// <summary>
    /// Definiert die Anwendungsklasse.
    /// </summary>
    class Program
    {
        /// <summary>
        /// Definiert den Einstiegspunkt in die Anwendung
        /// </summary>
        static void Main()
        {
            // Proxyobjekt deklarieren
            IwlbOrganizationManager objProxy = null;

            try
            {
                // Proxyobjekt instanziieren
                objProxy = ChannelFactory<IwlbOrganizationManager>.CreateChannel(
                    new NetTcpBinding(),
                    new EndpointAddress("net.tcp://localhost:4711/LearningWcf"));

                // Daten vom Server holen
                CwlbCompany objCompany = objProxy.GetOrganizationStructure(null);

                // Kontrollausgabe durchführen
                Console.WriteLine("Name der Firma:. . . . . . . {0}", objCompany.Name);
                Console.WriteLine("Name der CEO:  . . . . . . . {0}", objCompany.CEO.Name);
                Console.WriteLine("Name der CFO:  . . . . . . . {0}", objCompany.CFO.Name);
                Console.WriteLine("Name der Division: . . . . . {0}", objCompany.Division.Name);
                Console.WriteLine("Name des Managers: . . . . . {0}", objCompany.Division.Manager.Name);
                Console.WriteLine("Name der Vertragsabteilung:  {0}", objCompany.Division.Division.Name);
                Console.WriteLine("Name des Managers: . . . . . {0}", objCompany.Division.Division.Manager.Name);
            }
            catch (Exception excObject)
            {
                Console.WriteLine(excObject.Message);
            }
            finally
            {
                // Proxyobjekt ordentlich schliessen
                if (objProxy != null && ((IChannel)objProxy).State == CommunicationState.Opened)
                {
                    ((IChannel)objProxy).Close();
                }
                if (objProxy != null && ((IChannel)objProxy).State == CommunicationState.Faulted)
                {
                    ((IChannel)objProxy).Abort();
                }
            }
        }
    }
}
