﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WeroSoft.Samples
{
    /// <summary>
    /// Repräsentiert die Organisationsstruktur einer Firma.
    /// </summary>
    public class CwlbCompany
    {
        /// <summary>
        /// Liefert oder definiert die Objektidentifikation.
        /// </summary>
        public string Id { get; set; }

        /// <summary>
        /// Liefert oder definiert den Namen der Firma.
        /// </summary>
        public string Name { get; set; }

        /// <summary>
        /// Liefert oder definiert die untergeordnete Abteilung.
        /// </summary>
        public CwlbDivision Division { get; set; }

        /// <summary>
        /// Liefert oder definiert die Person in der Rolle des Geschäftsführers.
        /// </summary>
        public CwlbPerson CEO { get; set; }

        /// <summary>
        /// Liefert oder definiert die Person in der Rolle des Finanzchefs.
        /// </summary>
        public CwlbPerson CFO { get; set; }
    }
}
