﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace WeroSoft.Samples
{
    /// <summary>
    /// Repräsentiert eine Division innerhalb einer Firma.
    /// </summary>
    [DataContract(Name = "Division", Namespace = "http://WeroSoft.net/Samples/Data", IsReference = true)]
    public class CwlbDivision
    {
        /// <summary>
        /// Liefert oder definiert die Objektidentifikation.
        /// </summary>
        [DataMember(Order = 1)]
        public string Id { get; set; }

        /// <summary>
        /// Liefert oder definiert den Namen der Division.
        /// </summary>
        [DataMember(Order = 2)]
        public string Name { get; set; }

        /// <summary>
        /// Liefert oder definiert die Person, die die Division leitet.
        /// </summary>
        [DataMember(Order = 3)]
        public CwlbPerson Manager { get; set; }

        /// <summary>
        /// Liefert oder definiert die unterstellte Division.
        /// </summary>
        [DataMember(Order = 4)]
        public CwlbDivision Division { get; set; }
    }
}
