﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace WeroSoft.Samples
{
    /// <summary>
    /// Repräsentiert die Organisationsstruktur einer Firma.
    /// </summary>
    [DataContract(Name = "Company", Namespace = "http://WeroSoft.net/Samples/Data", IsReference = true)]
    public class CwlbCompany
    {
        /// <summary>
        /// Liefert oder definiert die Objektidentifikation.
        /// </summary>
        [DataMember(Order = 1)]
        public string Id { get; set; }

        /// <summary>
        /// Liefert oder definiert den Namen der Firma.
        /// </summary>
        [DataMember(Order = 2)]
        public string Name { get; set; }

        /// <summary>
        /// Liefert oder definiert die Person in der Rolle des Geschäftsführers.
        /// </summary>
        [DataMember(Order = 3)]
        public CwlbPerson CEO { get; set; }

        /// <summary>
        /// Liefert oder definiert die Person in der Rolle des Finanzchefs.
        /// </summary>
        [DataMember(Order = 4)]
        public CwlbPerson CFO { get; set; }

        /// <summary>
        /// Liefert oder definiert die untergeordnete Abteilung.
        /// </summary>
        [DataMember(Order = 5)]
        public List<CwlbDivision> Divisions { get; set; }
    }
}
