﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;

namespace WeroSoft.Samples
{
    /// <summary>
    /// Implementiert den Organisationsdienst.
    /// </summary>
    public class CwlbOrganizationManager : IwlbOrganizationManager
    {
        /// <summary>
        /// Liefert eine Organisationsstruktur.
        /// </summary>
        /// <param name="strCompanyId">Identifikation des zu liefernden Strukturelements.</param>
        /// <returns>Eine Struktur einer Organisation.</returns>
        public CwlbCompany GetOrganizationStructure(string strCompanyId)
        {
            // Daten fest codiert zusammenstellen
            CwlbCompany objCompany = new CwlbCompany { Name = "WCF Company", Id = Guid.NewGuid().ToString() };
            objCompany.CEO = new CwlbPerson { Name = "Master", Id = Guid.NewGuid().ToString() };
            objCompany.CFO = new CwlbPerson { Name = "Monait", Id = Guid.NewGuid().ToString() };
            objCompany.Divisions = new List<CwlbDivision>();
            objCompany.Divisions.Add( new CwlbDivision { Name = "Verträge", Id = Guid.NewGuid().ToString() });
            objCompany.Divisions[0].Manager = objCompany.CEO;
            objCompany.Divisions[0].Divisions = new List<CwlbDivision>();
            objCompany.Divisions[0].Divisions.Add(new CwlbDivision { Name = "Datenverträge", Id = Guid.NewGuid().ToString() });
            objCompany.Divisions[0].Divisions[0].Manager = objCompany.CFO;

            // Mitarbeiter ergänzen
            List<CwlbPerson> cobjPerson = new List<CwlbPerson>();
            cobjPerson.Add(new CwlbPerson { Name = "Ambrunnen", Id = Guid.NewGuid().ToString() });
            cobjPerson.Add(new CwlbPerson { Name = "Aufderalp", Id = Guid.NewGuid().ToString() });
            cobjPerson.Add(new CwlbPerson { Name = "Unterdorf", Id = Guid.NewGuid().ToString() });
            cobjPerson.Add(new CwlbPerson { Name = "Manner", Id = Guid.NewGuid().ToString() });
            cobjPerson.Add(new CwlbPerson { Name = "Blauer", Id = Guid.NewGuid().ToString() });
            objCompany.Divisions[0].Divisions[0].Employees = cobjPerson;

            // Daten ausliefern
            return objCompany;
        }
    }
}
