﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;
using System.Diagnostics;

namespace WeroSoft.Samples
{
    /// <summary>
    /// Repräsentiert die Organisationsstruktur einer Firma.
    /// </summary>
    [DataContract(Name = "Company", Namespace = "http://WeroSoft.net/Samples/Data", IsReference = true)]
    [DebuggerDisplay("{Name} - CEO: {CEO.Name}")]
    public class CwlbCompany : CwlbStructureElement
    {
        /// <summary>
        /// Liefert oder definiert die Person in der Rolle des Geschäftsführers.
        /// </summary>
        [DataMember(Order = 1)]
        public CwlbPerson CEO { get; set; }

        /// <summary>
        /// Liefert oder definiert die Person in der Rolle des Finanzchefs.
        /// </summary>
        [DataMember(Order = 2)]
        public CwlbPerson CFO { get; set; }
    }
}
