﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace WeroSoft.Samples
{
    /// <summary>
    /// Repräsentiert das abstrakte Wurzelelemente einer Organisationsstruktur.
    /// </summary>
    [DataContract(Name = "OrganizationPart", Namespace = "http://WeroSoft.net/Samples/Data", IsReference = true)]
    //[KnownType(typeof(CwlbPerson))]
    //[KnownType(typeof(CwlbOrganization))]
    //[KnownType(typeof(CwlbCompany))]
    [KnownType("GetKnownTypes")]
    public abstract class CwlbOrganizationPart : IwlbOrganizationPart, IExtensibleDataObject
    {
        /// <summary>
        /// Liefert oder definiert die unterstellte Division.
        /// </summary>
        [DataMember(Order = 0)]
        public CwlbStructureElement ParentOrganization { get; set; }

        /// <summary>
        /// Liefert oder definiert die Objektidentifikation.
        /// </summary>
        [DataMember(Order = 1)]
        public string Id { get; set; }

        /// <summary>
        /// Liefert oder definiert den Namen der Firma.
        /// </summary>
        [DataMember(Order = 2)]
        public string Name { get; set; }

        /// <summary>
        /// Liefert die Typen, die im Zusammenhang mit diesem Basistyp serialisiert werden.
        /// </summary>
        /// <returns>Definierte typen der Serialisierung über die WCF.</returns>
        private static Type[] GetKnownTypes()
        {
            return new Type[] {
                typeof(CwlbPerson),
                typeof(CwlbOrganization),
                typeof(CwlbCompany)
            };
        }

        /// <summary>
        /// Liefert oder definiert die Daten für die Versionserhaltung.
        /// </summary>
        public ExtensionDataObject ExtensionData {get; set; }
    }
}
