﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;

namespace WeroSoft.Samples.LearningWcfContract
{
    /// <summary>
    /// Definiert eine detaillierte Fehlerinformation für die Demo.
    /// </summary>
    [DataContract(Name = "FaultDetail", Namespace = "http://WeroSoft.net/Samples/Contracts")]
    public class CwlbFaultDetail : IwlbFaultDetail
    {
        /// <summary>
        /// Name der Maschine, auf der der Fehler aufgetreten ist.
        /// </summary>
        [DataMember(Name = "MachineName")]
        public string MachineName { get; set; }

        /// <summary>
        /// Name des Dienstes, in dem der Fehler aufgetreten ist.
        /// </summary>
        [DataMember(Name = "ServiceName")]
        public string ServiceName { get; set; }

        /// <summary>
        /// Name der Methode, in der die Fehlerbehandlung stattgefunden hat.
        /// </summary>
        [DataMember(Name = "MethodName")]
        public string MethodName { get; set; }
    }
}
