﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WeroSoft.Samples.LearningWcfContract
{
    /// <summary>
    /// Definiert ein Aargument für das Festhalten von Ereignissen des Beispiels
    /// </summary>
    public class CwlbInfoEventArgs : EventArgs
    {
        /// <summary>
        /// Liefert oder definiert eine textuelle Repräsentation des Senders des Arguments.
        /// </summary>
        public string Sender { get; set; }

        /// <summary>
        /// Liefert oder definiert einen Text der Situation.
        /// </summary>
        public string Text { get; set; }

        /// <summary>
        /// Liefert den Zeitstempel an dem das Ereignis hergestellt wurde.
        /// </summary>
        public DateTime Timestamp { get; private set; }

        /// <summary>
        /// Liefert eine textuelle Repräsentation des Zeitstempels.
        /// </summary>
        public string TimestampText
        {
            get
            {
                return Timestamp.ToString("HH:mm:ss.fff");
            }
        }

        /// <summary>
        /// Initialisiert eine neue Instanz der Klasse CwlbInfoEventArgs.
        /// </summary>
        public CwlbInfoEventArgs()
        {
            Timestamp = DateTime.Now;
        }
    }
}
