﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;

namespace WeroSoft.Samples.LearningWcfContract
{
    /// <summary>
    /// Definiert den Rückrufvertrag der Demo.
    /// </summary>
    public interface IwlbClientCallback
    {
        /// <summary>
        /// Rückrufmethode für einen blockierenden Rückruf.
        /// </summary>
        /// <param name="objEventArgs">Rückrufdaten.</param>
        [OperationContract(Name = "BlockingClientCallback")]
        void BlockingClientCallback(CwlbInfoEventArgs objEventArgs);

        /// <summary>
        /// Rückrufmethode für einen nicht blockierenden Rückruf.
        /// </summary>
        /// <param name="objEventArgs">Rückrufdaten.</param>
        [OperationContract(Name = "NonBlockingClientCallback", IsOneWay = true)]
        void NonBlockingClientCallback(CwlbInfoEventArgs objEventArgs);

        /// <summary>
        /// Rückrufmethode für einen zyklischen Aufruf.
        /// </summary>
        /// <param name="senderName">Name des Absenders dieses Aufrufs</param>
        /// <param name="objEventArgs">Rückrufdaten.</param>
        [OperationContract(Name = "CyclicClientCallback", IsOneWay = true)]
        void CyclicClientCallback(string senderName, CwlbInfoEventArgs objEventArgs);
    }
}
