﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using WeroSoft.Samples.LearningWcfContract;
using System.ServiceModel;

namespace WeroSoft.Samples.LearningWcfImplementation
{
    /// <summary>
    /// Implementierung des aufruforientierten Dienstes.
    /// </summary>
    [ServiceBehavior(InstanceContextMode=InstanceContextMode.PerCall)]
    public class CwlbDemoServicePerCall : CwlbDemoServiceBase
    {
        /// <summary>
        /// Hält eine Referenz auf den verwendeten Instanzkontext
        /// </summary>
        private static InstanceContext _objContext;

        /// <summary>
        /// Hält eine Referenz auf den verwendeten Instanzkontext
        /// </summary>
        protected override InstanceContext LastInstanceContext
        {
            get { return _objContext; }
            set { _objContext = value; }
        }

        /// <summary>
        /// Definiert eine einfache Methode für die Demonstration der Polymorphie in Diensten.
        /// </summary>
        /// <param name="strClientData">Daten, die der Client für den Ping an den Service übermittelt.</param>
        /// <returns>Formatierte Antwort des Dienstes.</returns>
        [OperationBehavior(ReleaseInstanceMode = ReleaseInstanceMode.BeforeAndAfterCall)]
        public override CwlbInfoEventArgs DemoCall(string strClientData)
        {
            return DemoCallPrepare(strClientData);
        }
    }
}
