﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel.Description;
using System.Text;
using WeroSoft.Samples.LearningWcfContract;

namespace WeroSoft.Samples.LearningWcfImplementation
{
    /// <summary>
    /// Klasse frü dei Konvertierung einer Ausnahme in ein Fehlerdetail.
    /// </summary>
    public sealed class CwlbFaultConverter : IwlbFaultConverter
    {
        /// <summary>
        /// Konvertiert eine Ausnahme in ein Fehlerdateil.
        /// </summary>
        /// <param name="objException">Ausnahme die konvertiert werden soll.</param>
        /// <param name="objServiceDescription">Dienstbeschreibung.</param>
        /// <returns>Fehlerdetail.</returns>
        public IwlbFaultDetail Convert(Exception objException, ServiceDescription objServiceDescription)
        {
            return new CwlbFaultDetail
            {
                MachineName = Environment.MachineName,
                ServiceName = objServiceDescription.Name,
                MethodName = "n.a."
            };
        }
    }
}
