﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;

namespace WeroSoft.Samples.LearningWcfContract
{
    /// <summary>
    /// Definiert den Demodienst für Rückrufe des Beispiels.
    /// </summary>
    [ServiceContract(Name="CallbackDemoService", Namespace="http://WeroSoft.net/Samples/Contracts", CallbackContract=typeof(IwlbClientCallback))]
    public interface IwlbCallbackDemoService : IwlbDemoService
    {
        /// <summary>
        /// Führt einen blockierenden Rückruf zum Client durch.
        /// </summary>
        /// <param name="strClientData"></param>
        [OperationContract(Name = "BlockingCallback")]
        void BlockingCallback(string strClientData);

        /// <summary>
        /// Führt einen nicht blockierenden Rückruf zum Client durch
        /// </summary>
        /// <param name="strClientData"></param>
        [OperationContract(Name = "NonBlockingCallback")]
        void NonBlockingCallback(string strClientData);

        /// <summary>
        /// Registriert den Client für einen zyklischen Rückruf.
        /// </summary>
        [OperationContract(Name = "RegisterClient")]
        void RegisterClient();

        /// <summary>
        /// Deregistriert den Client für einen zyklischen Rückruf.
        /// </summary>
        [OperationContract(Name = "UnregisterClient")]
        void UnregisterClient();

        /// <summary>
        /// Ändert die Zykluszeit für zyklische Rückrufe im Dienst.
        /// </summary>
        /// <param name="dValue"></param>
        [OperationContract(Name = "SetInterval")]
        void SetInterval(double dValue);
    }
}
