﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;

namespace WeroSoft.Samples.LearningWcfContract
{
    /// <summary>
    /// Definiert den Demodienst des Beispiels.
    /// </summary>
    [ServiceContract(Name="DemoService", Namespace="http://WeroSoft.net/Samples/Contracts")]
    public interface IwlbDemoService
    {
        /// <summary>
        /// Löst einen applikatorischen Ping aus.
        /// </summary>
        /// <param name="strClientData">Daten, die der Client für den Ping an den Service übermittelt.</param>
        /// <returns>Formatierte Antwort des Dienstes.</returns>
        [OperationContract(Name = "Ping")]
        CwlbInfoEventArgs Ping(string strClientData);

        /// <summary>
        /// Definiert eine einfache Methode für die Demonstration der Polymorphie in Diensten.
        /// </summary>
        /// <param name="strClientData">Daten, die der Client für den Ping an den Service übermittelt.</param>
        /// <returns>Formatierte Antwort des Dienstes.</returns>
        [OperationContract(Name = "DemoCall")]
        CwlbInfoEventArgs DemoCall(string strClientData);
    }
}
