﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;

namespace WeroSoft.Samples.LearningWcfImplementation
{
    /// <summary>
    /// 
    /// </summary>
    public class CwlbContextInfo : IExtension<IContextChannel>
    {
        /// <summary>
        /// Liefert oder definiert die identifikation des Info-Objekts.
        /// </summary>
        public string Id { get; private set; }

        /// <summary>
        /// Liefert oder definiert den Instanzkontext des Objekts.
        /// </summary>
        public InstanceContext Instance { get; set; }

        /// <summary>
        /// Initialisiert ein neues Objekte der Klasse CwlbContextInfo.
        /// </summary>
        /// <param name="strId">Identifikation des Objekts.</param>
        public CwlbContextInfo(string strId)
        {
            Id = strId;
        }

        /// <summary>
        /// Aktiviert ein Erweiterungsobjekt, um herauszufinden, wann es aggregiert wurde.
        /// Wird aufgerufen, wenn die Erweiterung in die IExtensibleObject(Of T).Extensions-Eigenschaft 
        /// eingefügt wird. 
        /// </summary>
        /// <param name="objOwner">Das erweiterbare Objekt, das diese Erweiterung aggregiert.</param>
        public void Attach(IContextChannel objOwner)
        {
        }

        /// <summary>
        /// Aktiviert ein Objekt, um zu kennzeichnen, wenn es nicht mehr aggregiert wird.
        /// Wird aufgerufen, wenn eine Erweiterung aus der IExtensibleObject(Of T).Extensions-Eigenschaft 
        /// entfernt wird. 
        /// </summary>
        /// <param name="objOwner">Das erweiterbare Objekt, das diese Erweiterung aggregiert.</param>
        public void Detach(IContextChannel objOwner)
        {
        }
    }
}
