﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;

namespace WeroSoft.Samples
{
    /// <summary>
    /// Definiert die Schnittstelle des Dienstes.
    /// </summary>
    [ServiceContract(Name = "DemoService", Namespace = "http://WeroSoft.net/Samples")]
    public interface IDemoService
    {
        /// <summary>
        /// Liefert ein Array von Daten.
        /// </summary>
        /// <param name="demoData">Datenobjekt das als Vorlage vom Client an den Server gesendet wird.</param>
        /// <param name="iParam">Anzahl der zu generierenden Elemente in der Rückgabe. Dieser WErt darf nicht kleiner als 1 sein.</param>
        /// <returns>Array von serverseitig erzeugten Elementen.</returns>
        [OperationContract(Name = "GetDemoData")]
        CwlbDemoData[] GetDemoData(CwlbDemoData demoData, int iParam);
    }
}
