﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;

namespace WeroSoft.Samples
{
    /// <summary>
    /// Definiert die Schnittstelle des Dienstes.
    /// </summary>
    [ServiceContract(Name = "AspNetCompatibilityDemoService", Namespace = "http://WeroSoft.net/Samples")]
    public interface IwlbAspNetCompatibilityDemoService
    {
        /// <summary>
        /// Liefert ein Datenelement, dessen Zahl interne Zahl von der Anzahl der Zugriffe abhängt.
        /// </summary>
        /// <param name="demoData">Datenobjekt das als Vorlage vom Client an den Server gesendet wird.</param>
        /// <returns>Serverseitig verändertes Element.</returns>
        [OperationContract(Name = "GetDemoData")]
        CwlbDemoData GetDemoData(CwlbDemoData demoData);

        [OperationContract(Name = "GetContextInfo")]
        Dictionary<string, string> GetContextInfo();
    }
}
