﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using System.ServiceModel.Channels;

namespace WeroSoft.Samples
{
    /// <summary>
    /// Testprogramm für den Client.
    /// </summary>
    class Program
    {
        /// <summary>
        /// Einstiegspunkt in das Testprogramm
        /// </summary>
        static void Main()
        {
            // Client deklarieren
            Client.DemoServiceClient objClient = null;
            try
            {
                // Identifikation
                Console.WriteLine("Client generiert mit Dienstreferenz in Visual Studio");

                // Client erstellen
                objClient = new Client.DemoServiceClient("Tcp");

                // Daten erstellen und Kommunikation durchführen
                CwlbDemoData objDemoData = new CwlbDemoData { StringValue = "Anforderung" };
                CwlbDemoData[] aobjDemoData = objClient.GetDemoData(objDemoData, 10);
                foreach (CwlbDemoData objItem in aobjDemoData)
                {
                    Console.WriteLine(string.Format("{0} {1,2}. {2}",
                        objItem.DateTimeValue.ToShortDateString(),
                        objItem.IntegerValue,
                        objItem.StringValue));
                }
            }
            catch (CommunicationException excObject)
            {
                Console.WriteLine(excObject.Message);
            }
            catch (Exception excObject)
            {
                Console.WriteLine(excObject.Message);
            }
            finally
            {
                if (objClient != null && objClient.State == CommunicationState.Opened)
                {
                    objClient.Close();
                }
                if (objClient != null && objClient.State == CommunicationState.Faulted)
                {
                    objClient.Abort();
                }
            }
        }
    }
}
