﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;

namespace WeroSoft.Samples
{
    /// <summary>
    /// Definiert eine eigene Clientklasse.
    /// </summary>
    public class CwlbCallbackClient : DuplexClientBase<IwlbCallbackService>, IwlbCallbackService
    {
        /// <summary>
        /// Initialisiert eine neue Instanz der Klasse CwlbClient.
        /// </summary>
        public CwlbCallbackClient(CwlbCallback objCallback)
            : base(objCallback)
        {
        }

        /// <summary>
        /// Initialisiert eine neue Instanz der Klasse CwlbClient.
        /// </summary>
        /// <param name="strConfigurationName">Definiert den Namen der verwendeten Endpunktkonfiguration.</param>
        public CwlbCallbackClient(CwlbCallback objCallback, string strConfigurationName) :
            base(objCallback, strConfigurationName)
        {
        }

        /// <summary>
        /// Meldet den Client für den Erhalt von Rückrufen an.
        /// </summary>
        public void RegisterListener()
        {
            this.Channel.RegisterListener();
        }

        /// <summary>
        /// Meldet den Client für den Erhalt von Rückrufen ab.
        /// </summary>
        public void UnregisterListener()
        {
            this.Channel.UnregisterListener();
        }
    }
}
