﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel.Description;

namespace WeroSoft.Samples
{
    /// <summary>
    /// Definiert eine eigene Clientklasse.
    /// </summary>
    public class CwlbClient : System.ServiceModel.ClientBase<IwlbDemoService>, IwlbDemoService
    {
        /// <summary>
        /// Initialisiert eine neue Instanz der Klasse CwlbClient.
        /// </summary>
        public CwlbClient()
        {
        }

        /// <summary>
        /// Initialisiert eine neue Instanz der Klasse CwlbClient.
        /// </summary>
        /// <param name="objEndpoint">Dienstendpunkt der für die Konfiguration verwendet werden soll.</param>
        public CwlbClient(ServiceEndpoint objEndpoint)
            : base(objEndpoint)
        {
        }


        /// <summary>
        /// Initialisiert eine neue Instanz der Klasse CwlbClient.
        /// </summary>
        /// <param name="strConfigurationName">Definiert den Namen der verwendeten Endpunktkonfiguration.</param>
        public CwlbClient(string strConfigurationName) :
            base(strConfigurationName)
        {
        }

        /// <summary>
        /// Stellt die Methode des Deinstes zur Verfügung.
        /// </summary>
        /// <param name="objDemoData">Demodatenobjekt.</param>
        /// <param name="iParam">Anzahl der Einträge im Array.</param>
        /// <returns>Array mit Objektn des Typs der Demodaten.</returns>
        public CwlbDemoData[] GetDemoData(CwlbDemoData objDemoData, int iParam)
        {
            return this.Channel.GetDemoData(objDemoData, iParam);
        }
    }
}
