﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;

namespace WeroSoft.Samples
{
    /// <summary>
    /// Definition des Demodienstes mit Rückruffunktionen
    /// </summary>
    [ServiceContract(Name = "CallbackService", Namespace = "http://WeroSoft.net/Samples", CallbackContract=typeof(IwlbCallbackContract))]
    public interface IwlbCallbackService
    {
        /// <summary>
        /// Registriert einen Zuhörer für den Empfang der Serverzeit.
        /// </summary>
        [OperationContract(Name = "RegisterListener")]
        void RegisterListener();

        /// <summary>
        /// Deregisitiert einen Zuhörer für den Empfang der Serverzeit.
        /// </summary>
        [OperationContract(Name = "UnregisterListener")]
        void UnregisterListener();
    }
}
