﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using System.ServiceModel.MsmqIntegration;

namespace WeroSoft.Samples
{
    /// <summary>
    /// Implementiert den Service Host.
    /// </summary>
    class Program
    {
        /// <summary>
        /// Einsprungpunkt in das Programm.
        /// </summary>
        static void Main(string[] astrArguments)
        {
            // Definiert den Service Host.
            ServiceHost objHost = null;
            ServiceHost objCallbackHost = null;

            try
            {
                // Erstellen der Servicehosts
                objHost = new ServiceHost(typeof(CwlbDemoService));
                objCallbackHost = new ServiceHost(typeof(CwlbCallbackService));
                // Dienste starten
                objHost.Open();
                objCallbackHost.Open();
                // Verhindern das Prozess beendet wird.
                Console.WriteLine("Service Host sind gestartet. Mit einem Tastendruck beenden ...");
                Console.ReadKey(true);
            }
            catch (Exception excObject)
            {
                // Ausnahmebehandlung
                Console.WriteLine(excObject.Message);
            }
            finally
            {
                // Beenden des Dienstes im Normalfall
                if (objHost != null && objHost.State == CommunicationState.Opened)
                {
                    objHost.Close();
                }
                // Beenden des Dienstes im Ausnahmefall
                if (objHost != null && objHost.State == CommunicationState.Faulted)
                {
                    objHost.Abort();
                }
                // Beenden des Dienstes im Normalfall
                if (objCallbackHost != null && objCallbackHost.State == CommunicationState.Opened)
                {
                    objCallbackHost.Close();
                }
                // Beenden des Dienstes im Ausnahmefall
                if (objCallbackHost != null && objCallbackHost.State == CommunicationState.Faulted)
                {
                    objCallbackHost.Abort();
                }
            }
        }
    }
}
