﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;

namespace WeroSoft.Samples
{
    /// <summary>
    /// Implementierung des Dienstes IwlbDemoService.
    /// </summary>
    [ServiceBehavior(InstanceContextMode=InstanceContextMode.PerCall)]
    public class CwlbDemoService : IwlbDemoService
    {
        [ThreadStatic]
        public int IntField = 7;

        /// <summary>
        /// Liefert ein Datenarray.
        /// </summary>
        /// <param name="demoData">Datenobjekt, das als Vorlage vom Client an den Server gesendet wird.</param>
        /// <param name="iParam">Anzahl der zu generierenden Elemente in der Rückgabe. Dieser Wert darf nicht kleiner als 1 sein.</param>
        /// <returns>Array von serverseitig erzeugten Elementen.</returns>
        public CwlbDemoData[] GetDemoData(CwlbDemoData objDemoData, int iParam)
        {
            // Herstellen der Daten
            List<CwlbDemoData> cobjData = new List<CwlbDemoData>();
            for (int iCount = 0; iCount < iParam; iCount++)
            {
                CwlbDemoData objData = new CwlbDemoData();
                objData.IntegerValue = iCount + 1;
                objData.StringValue = objDemoData.StringValue + " + Antwort";
                objData.DateTimeValue = new DateTime(2012, 1, 1) + TimeSpan.FromDays(10 * iCount);
                cobjData.Add(objData);
            }

            return cobjData.ToArray();
        }
    }
}
