﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Threading;
using WeroSoft.Samples.LearningWcfContracts;

namespace WeroSoft.Samples.LearningWcfClientUI
{
    /// <summary>
    /// Definiert die Klasse für Rückrufe vom Server.
    /// </summary>
    [CallbackBehavior(UseSynchronizationContext=false)]
    public class CwlbDemoDispatcherCallback : CwlbCallbackBase, IwlbDemoDispatcherCallback
    {
        /// <summary>
        /// Definiert den Delegaten für den clientinternen Rückruf in die Benutzeroberfläche.
        /// </summary>
        public event Action<Guid> Done = delegate { };

        /// <summary>
        /// Führt den Rückruf durch. Diese Methode führt einen automatischen Threadwechsel durch.
        /// </summary>
        /// <param name="objId">Identifizierung des erledigten Elements.</param>
        public void OnFinished(Guid objId)
        {
            if (ClientUIDispatcher.CheckAccess())
            {
                Done(objId);
            }
            else
            {
                Action<Guid> action = OnFinished;
                ClientUIDispatcher.BeginInvoke(action, objId);
            }
        }
    }
}
