﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Text;
using System.Threading.Tasks;
using WeroSoft.Samples.LearningWcfContracts;

namespace WeroSoft.Samples.LearningWcfClientUI
{
    /// <summary>
    /// Definiert die Klasse für Rückrufe vom Server.
    /// </summary>
    [CallbackBehavior(UseSynchronizationContext=false)]
    public class CwlbDemoServiceCallback : CwlbCallbackBase, IwlbDemoServiceCallback
    {
        /// <summary>
        /// Definiert den Delegaten für den clientinternen Rückruf in die Benutzeroberfläche.
        /// </summary>
        public event Action<DateTime> Time = delegate { };

        /// <summary>
        /// Führt den Rückruf durch. Diese Methode führt einen automatischen Threadwechsel durch.
        /// </summary>
        /// <param name="time">Zeitstempel vom Server.</param>
        public void OnTime(DateTime time)
        {
            if (ClientUIDispatcher.CheckAccess())
            {
                Time(time);
            }
            else
            {
                Action<DateTime> action = OnTime;
                ClientUIDispatcher.BeginInvoke(action, time);
            }
        }
    }
}
