﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WeroSoft.Samples.LearningWcfContracts
{
    /// <summary>
    /// Daten eines Jobs einer unabhängigen serverseitigen Verarbeitung.
    /// </summary>
    public class CwlbJob
    {
        /// <summary>
        /// Liefert oder definiert die Identifikation des Jobs.
        /// </summary>
        public Guid Id { get; set; }

        /// <summary>
        /// Liefert oder definiert den Namen des Jobs.
        /// </summary>
        public string Name { get; set; }

        /// <summary>
        /// Liefert oder definiert die Laufzeit des Jobs in Sekunden.
        /// </summary>
        public int Workload { get; set; }

        /// <summary>
        /// Liefert oder definiert den Empfangszeitpunkt des Servers.
        /// </summary>
        public DateTime SendToService { get; set; }

        /// <summary>
        /// Liefert oder definiert den Startzeitpunkt des Jobs auf dem Server.
        /// </summary>
        public DateTime Started { get; set; }

        /// <summary>
        /// Liefert oder definiert den Endzeitpunkt des Jobs.
        /// </summary>
        public DateTime Ended { get; set; }

        /// <summary>
        /// Liefret oder definiert den Status des Jobs.
        /// </summary>
        public EwlbJobState Status { get; set; }
    }
}
