﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WeroSoft.Samples.LearningWcfContracts
{
    /// <summary>
    /// Definiert die möglichen Status, die ein Job annahmen kann.
    /// </summary>
    public enum EwlbJobState
    {
        /// <summary>
        /// Der Job wurde vom Client an den Ddienst übermittelt, jedoch noch nicht gestartet.
        /// </summary>
        Scheduled,

        /// <summary>
        /// Der Job wurde gestartet.
        /// </summary>
        Running,

        /// <summary>
        /// Der Job ist normal beendet worden, die Resultate jedoch noch nicht abgeholt.
        /// </summary>
        Ended,

        /// <summary>
        /// Der Job ist mit einem Fehler beendet worden.
        /// </summary>
        Exception,

        /// <summary>
        /// Der laufende Job soll abgebrochen werden.
        /// </summary>
        Cancelling,

        /// <summary>
        /// Der Job wurde abgebrochen.
        /// </summary>
        Cancelled
    }
}
