﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Text;
using System.Threading.Tasks;

namespace WeroSoft.Samples.LearningWcfContracts
{
    /// <summary>
    /// Definiert die Schnittstelle für den Demo Service.
    /// </summary>
    [ServiceContract(Name = "DemoDispatcherService", Namespace = GwlbGlobals.WcfNamespace, CallbackContract = typeof(IwlbDemoDispatcherCallback))]
    public interface IwlbDemoDispatcherService
    {
        /// <summary>
        /// Registriert den Client beim Server für die Rückrufe.
        /// </summary>
        /// <param name="objSenderId">Identifikation des Senders für den Rückruf.</param>
        [OperationContract(Name = "Register", IsOneWay = true)]
        void Register(Guid objSenderId);

        /// <summary>
        /// Führt einen Job im Dispatcher aus.
        /// </summary>
        /// <param name="objDispatcherJob">Job der für die Ausführung vorgesehen ist.</param>
        [OperationContract(Name = "Execute", IsOneWay = true)]
        void Execute(CwlbDispatcherJob objDispatcherJob);

        /// <summary>
        /// Hebt die Registrierung des Client beim Server für die Rückrufe auf.
        /// </summary>
        /// <param name="objSenderId">Identifikation des Senders.</param>
        [OperationContract(Name = "Unregister", IsOneWay = true)]
        void Unregister(Guid objSenderId);
    }
}
