﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Text;
using System.Threading.Tasks;

namespace WeroSoft.Samples.LearningWcfContracts
{
    /// <summary>
    /// Definiert die Schnittstelle für den Demo Service.
    /// </summary>
    [ServiceContract(Name="DemoWorkerService", Namespace=GwlbGlobals.WcfNamespace)]
    public interface IwlbDemoWorkerService : IDisposable
    {
        /// <summary>
        /// Liefert die Liste der aktuellen Jobs im System.
        /// </summary>
        /// <returns>Liste der Jobs.</returns>
        [OperationContract(Name="GetAllJobs")]
        List<CwlbJob> GetAllJobs();

        /// <summary>
        /// Registriert einen neuen Job im System.
        /// </summary>
        /// <param name="objJob">Daten des neuen Jobs.</param>
        [OperationContract(Name = "RegisterJob")]
        void RegisterJob(CwlbJob objJob);

        /// <summary>
        /// Löscht einen bestehenden Job aus dem System.
        /// </summary>
        /// <param name="objJobId">Identifikation des zu löschenden Jobs.</param>
        /// <returns>True, wenn der Job gelöscht wurde, anderfalls false.</returns>
        [OperationContract(Name = "DeleteJob")]
        bool DeleteJob(Guid objJobId);
    }
}
