﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Text;
using System.Threading.Tasks;
using WeroSoft.Samples.LearningWcfService;

namespace WeroSoft.Samples.LearningWcfHost
{
    /// <summary>
    /// Programm für das Hosting der Demodienste.
    /// </summary>
    class Program
    {
        /// <summary>
        /// Einsprungpunkt in das Programm
        /// </summary>
        static void Main()
        {
            ServiceHost objHost = null;
            ServiceHost objWorkerHost = null;
            ServiceHost objDispatcherHost = null;

            try
            {
                // Starten des Demodienstes
                objHost = new ServiceHost(typeof(CwlbDemoServicePerSession));
                objWorkerHost = new ServiceHost(typeof(CwlbDemoWorkerService));
                objDispatcherHost = new ServiceHost(typeof(CwlbDemoDispatcherService));
                objHost.Open();
                objWorkerHost.Open();
                objDispatcherHost.Open();

                // Konsolenprogramm am Leben erhalten
                Console.WriteLine("Host startet ...");
                Console.ReadKey(true);
            }
            catch (Exception exception)
            {
                Console.WriteLine(exception.Message);
            }
            finally
            {
                if (objHost != null)
                {
                    if (objHost.State == CommunicationState.Opened)
                    {
                        objHost.Close();
                    }
                    else if (objHost.State == CommunicationState.Faulted)
                    {
                        objHost.Abort();
                    }
                }
                if (objWorkerHost != null)
                {
                    if (objWorkerHost.State == CommunicationState.Opened)
                    {
                        objWorkerHost.Close();
                    }
                    else if (objWorkerHost.State == CommunicationState.Faulted)
                    {
                        objWorkerHost.Abort();
                    }
                }
                if (objDispatcherHost != null)
                {
                    if (objDispatcherHost.State == CommunicationState.Opened)
                    {
                        objDispatcherHost.Close();
                    }
                    else if (objDispatcherHost.State == CommunicationState.Faulted)
                    {
                        objDispatcherHost.Abort();
                    }
                }
            }
        }
    }
}
