﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using WeroSoft.Samples.LearningWcfContracts;

namespace WeroSoft.Samples.LearningWcfService
{
    /// <summary>
    /// Implementiert ein Arbeitsobjekt für einen Job.
    /// </summary>
    public class CwlbDispatcherJobWorker
    {
        /// <summary>
        /// Liefert oder definiert die Jobdaten.
        /// </summary>
        public CwlbDispatcherJob Job { get; private set; }

        /// <summary>
        /// Liefert oder definiert die Dienstinstanz, die für den Rückruf notwendig ist
        /// </summary>
        public CwlbDemoDispatcherService Service { get; private set; }

        /// <summary>
        /// Initialisiert ein neues Job Worker Objekt.
        /// </summary>
        /// <param name="objJob"></param>
        public CwlbDispatcherJobWorker(CwlbDispatcherJob objJob, CwlbDemoDispatcherService objService)
        {
            Job = objJob;
            Service = objService;
        }

        /// <summary>
        /// Arbeitsmethode des Threads.
        /// </summary>
        /// <param name="objStatus">Statusobjekt (nicht benutzt).</param>
        public void Execute()
        {
            Thread.Sleep(Job.Workload);
        }

        /// <summary>
        /// Führt den Rückruf an den Client durch.
        /// </summary>
        public void OnFinished()
        {
            Service.OnFinished(Job);
        }
    }
}
