﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WeroSoft.Samples.LearningWcfContracts
{
    /// <summary>
    /// Definiert die Daten eines Kontos einer Person
    /// </summary>
    public class CwlbAccount
    {
        /// <summary>
        /// Liefert oder definiert die Identifikation des Kontos.
        /// </summary>
        public Guid AccountId { get; set; }

        /// <summary>
        /// Liefert oder definiert die Identifikation der Person, der das Konto gehört.
        /// </summary>
        public Guid PersonId { get; set; }

        /// <summary>
        /// Liefert oder definiert die Bezeichnugn des Kontos.
        /// </summary>
        public string Name { get; set; }

        /// <summary>
        /// Liefert oder definiert die Währung in der das Konto geführt wird.
        /// </summary>
        public string Currency { get; set; }

        /// <summary>
        /// Liefert oder definiert den Startwert des Kontos
        /// </summary>
        public double StartingBalance { get; set; }

        /// <summary>
        /// Liefert oder definiert den aktuellen Saldo des Kontos.
        /// </summary>
        public double CurrentBalance { get; set; }
    }
}
