﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WeroSoft.Samples.LearningWcfContracts
{
    /// <summary>
    /// Definiert die Daten einer Geldtransaktion von einem Konto auf das andere.
    /// </summary>
    public class CwlbMoneyTransaction
    {
        /// <summary>
        /// Liefert oder definiert die Identifikation der Geldtransaktion.
        /// </summary>
        public Guid TransactionId { get; set; }

        /// <summary>
        /// Liefert oder definiert das Belastungskonto.
        /// </summary>
        public Guid AccountIdDebit { get; set; }

        /// <summary>
        /// Liefert oder definiert das Gutschriftskonto
        /// </summary>
        public Guid AccountIdCredit { get; set; }

        /// <summary>
        /// Liefert oder definiert den Betrag der Transaktion
        /// </summary>
        public double Amount { get; set; }

        /// <summary>
        /// Liefert oder definiert das Gültigkeitsdatum der Transaktion.
        /// </summary>
        public DateTime ValidityDate { get; set; }

        /// <summary>
        /// Liefert oder definiert das Buchungsdatum.
        /// </summary>
        public DateTime AccountingDate { get; set; }
    }
}
