
-- --------------------------------------------------
-- Entity Designer DDL Script for SQL Server 2005, 2008, and Azure
-- --------------------------------------------------
-- Date Created: 07/07/2012 12:11:02
-- Generated from EDMX file: C:\TeamDev\Books\HB.NET.Edition.2.Band.3\Kapitel_09\LearningWcf_09b\WeroSoft.Samples.LearningWcfDatabase\Model.edmx
-- --------------------------------------------------

SET QUOTED_IDENTIFIER OFF;
GO
USE [WeroSoft.Samples.LearningWcf09];
GO
IF SCHEMA_ID(N'dbo') IS NULL EXECUTE(N'CREATE SCHEMA [dbo]');
GO

-- --------------------------------------------------
-- Dropping existing FOREIGN KEY constraints
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[FK_PersonAccount]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[AccountSet] DROP CONSTRAINT [FK_PersonAccount];
GO
IF OBJECT_ID(N'[dbo].[FK_TransactionsAccount]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[TransactionSet] DROP CONSTRAINT [FK_TransactionsAccount];
GO
IF OBJECT_ID(N'[dbo].[FK_TransactionsAccount1]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[TransactionSet] DROP CONSTRAINT [FK_TransactionsAccount1];
GO

-- --------------------------------------------------
-- Dropping existing tables
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[AccountSet]', 'U') IS NOT NULL
    DROP TABLE [dbo].[AccountSet];
GO
IF OBJECT_ID(N'[dbo].[PersonSet]', 'U') IS NOT NULL
    DROP TABLE [dbo].[PersonSet];
GO
IF OBJECT_ID(N'[dbo].[TransactionSet]', 'U') IS NOT NULL
    DROP TABLE [dbo].[TransactionSet];
GO

-- --------------------------------------------------
-- Creating all tables
-- --------------------------------------------------

-- Creating table 'AccountSet'
CREATE TABLE [dbo].[AccountSet] (
    [AccountId] uniqueidentifier  NOT NULL,
    [Name] nvarchar(max)  NOT NULL,
    [Currency] nvarchar(max)  NOT NULL,
    [StartingBalance] float  NOT NULL,
    [CurrentBalance] float  NOT NULL,
    [Person_PersonId] uniqueidentifier  NOT NULL
);
GO

-- Creating table 'PersonSet'
CREATE TABLE [dbo].[PersonSet] (
    [PersonId] uniqueidentifier  NOT NULL,
    [Name] nvarchar(100)  NOT NULL,
    [FirstName] nvarchar(100)  NOT NULL
);
GO

-- Creating table 'MoneyTransactionSet'
CREATE TABLE [dbo].[MoneyTransactionSet] (
    [TransactionId] uniqueidentifier  NOT NULL,
    [AccountingDate] datetime  NOT NULL,
    [ValidityDate] datetime  NOT NULL,
    [Amount] float  NOT NULL,
    [AccountDebit_AccountId] uniqueidentifier  NOT NULL,
    [AccountCredit_AccountId] uniqueidentifier  NOT NULL
);
GO

-- --------------------------------------------------
-- Creating all PRIMARY KEY constraints
-- --------------------------------------------------

-- Creating primary key on [AccountId] in table 'AccountSet'
ALTER TABLE [dbo].[AccountSet]
ADD CONSTRAINT [PK_AccountSet]
    PRIMARY KEY CLUSTERED ([AccountId] ASC);
GO

-- Creating primary key on [PersonId] in table 'PersonSet'
ALTER TABLE [dbo].[PersonSet]
ADD CONSTRAINT [PK_PersonSet]
    PRIMARY KEY CLUSTERED ([PersonId] ASC);
GO

-- Creating primary key on [TransactionId] in table 'MoneyTransactionSet'
ALTER TABLE [dbo].[MoneyTransactionSet]
ADD CONSTRAINT [PK_MoneyTransactionSet]
    PRIMARY KEY CLUSTERED ([TransactionId] ASC);
GO

-- --------------------------------------------------
-- Creating all FOREIGN KEY constraints
-- --------------------------------------------------

-- Creating foreign key on [Person_PersonId] in table 'AccountSet'
ALTER TABLE [dbo].[AccountSet]
ADD CONSTRAINT [FK_PersonAccount]
    FOREIGN KEY ([Person_PersonId])
    REFERENCES [dbo].[PersonSet]
        ([PersonId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_PersonAccount'
CREATE INDEX [IX_FK_PersonAccount]
ON [dbo].[AccountSet]
    ([Person_PersonId]);
GO

-- Creating foreign key on [AccountDebit_AccountId] in table 'MoneyTransactionSet'
ALTER TABLE [dbo].[MoneyTransactionSet]
ADD CONSTRAINT [FK_TransactionsAccount]
    FOREIGN KEY ([AccountDebit_AccountId])
    REFERENCES [dbo].[AccountSet]
        ([AccountId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_TransactionsAccount'
CREATE INDEX [IX_FK_TransactionsAccount]
ON [dbo].[MoneyTransactionSet]
    ([AccountDebit_AccountId]);
GO

-- Creating foreign key on [AccountCredit_AccountId] in table 'MoneyTransactionSet'
ALTER TABLE [dbo].[MoneyTransactionSet]
ADD CONSTRAINT [FK_TransactionsAccount1]
    FOREIGN KEY ([AccountCredit_AccountId])
    REFERENCES [dbo].[AccountSet]
        ([AccountId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_TransactionsAccount1'
CREATE INDEX [IX_FK_TransactionsAccount1]
ON [dbo].[MoneyTransactionSet]
    ([AccountCredit_AccountId]);
GO

-- --------------------------------------------------
-- Script has ended
-- --------------------------------------------------