﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Text;
using System.Threading.Tasks;
using WeroSoft.Samples.LearningWcfService;

namespace WeroSoft.Samples.LearningWcfHost
{
    /// <summary>
    /// Programm für das Hosting der Demodienste.
    /// </summary>
    class Program
    {
        /// <summary>
        /// Einsprungpunkt in das Programm
        /// </summary>
        static void Main()
        {
            ServiceHost objHost = null;

            try
            {
                // Starten des Demodienstes
                objHost = new ServiceHost(typeof(CwlbAccountingService));
                objHost.Open();

                // Konsolenprogramm am Leben erhalten
                Console.WriteLine("Host startet ...");
                Console.ReadKey(true);
            }
            catch (Exception exception)
            {
                Console.WriteLine(exception.Message);
            }
            finally
            {
                if (objHost != null)
                {
                    if (objHost.State == CommunicationState.Opened)
                    {
                        objHost.Close();
                    }
                    else if (objHost.State == CommunicationState.Faulted)
                    {
                        objHost.Abort();
                    }
                }
            }
        }
    }
}
