﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Text;
using System.Threading.Tasks;
using WeroSoft.Samples.LearningWcfContracts;

namespace WeroSoft.Samples.LearningWcfClient
{
    /// <summary>
    /// Implementiert den Rückrufvertrag für den Client der Demo.
    /// </summary>
    [CallbackBehavior(UseSynchronizationContext=false)]
    internal class CwlbDocumentManagementCallback : IwlbDocumentManagementCallback
    {
        /// <summary>
        /// Wird ausgelöst, wenn der Server ein neues Dokument registriert hat.
        /// </summary>
        public event EventHandler<DocumentEventArgs> DocumentAdded = delegate { };

        /// <summary>
        /// Wird ausgelöst, wenn auf dem Server ein Dokument gelöscht wurde.
        /// </summary>
        public event EventHandler<DocumentEventArgs> DocumentRemoved = delegate { };

        /// <summary>
        /// Rückruf beim Hinzufügen eines neuen Dokuments auf dem Server.
        /// </summary>
        /// <param name="objDocumentHeader">Header der hinzugefügten Datei.</param>
        public void OnAddedDocument(CwlbDocumentHeader objDocumentHeader)
        {
            DocumentAdded(this, new DocumentEventArgs{ DocumentHeader = objDocumentHeader});
        }

        /// <summary>
        /// Rückruf beim Löschen eines bestehenden Dokuments auf dem Server.
        /// </summary>
        /// <param name="objDocumentHeader">Header der gelöschten Datei.</param>
        public void OnRemovedDocument(CwlbDocumentHeader objDocumentHeader)
        {
            DocumentRemoved(this, new DocumentEventArgs { DocumentHeader = objDocumentHeader });
        }
    }
}
