﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.ServiceModel;
using System.Text;
using System.Threading.Tasks;

namespace WeroSoft.Samples.LearningWcfContracts
{
    /// <summary>
    /// Definiert die Rückrufschnittstelle für dei Behandlung von Dokumenten.
    /// </summary>
    public interface IwlbDocumentManagementCallback
    {
        /// <summary>
        /// Rückruf beim Hinzufügen eines neuen Dokuments auf dem Server.
        /// </summary>
        /// <param name="objDocumentHeader">Header der hinzugefügten Datei.</param>
        [OperationContract(Name = "AddedDocument", IsOneWay = true)]
        void OnAddedDocument(CwlbDocumentHeader objDocumentHeader);

        /// <summary>
        /// Rückruf beim Löschen eines bestehenden Dokuments auf dem Server.
        /// </summary>
        /// <param name="objDocumentHeader">Header der gelöschten Datei.</param>
        [OperationContract(Name = "RemovedDocument", IsOneWay = true)]
        void OnRemovedDocument(CwlbDocumentHeader objDocumentHeader);
    }
}
