﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.ServiceModel;
using System.Text;
using System.Threading.Tasks;

namespace WeroSoft.Samples.LearningWcfContracts
{
    /// <summary>
    /// Definiert den Vertrag für die Verwaltung von Dokumenten auf dem Server.
    /// </summary>
    [ServiceContract(Name = "DocumentManager", Namespace = "http://WeroSoft.net/Samples", CallbackContract = typeof(IwlbDocumentManagementCallback))]
    public interface IwlbDocumentManager
    {
        /// <summary>
        /// Liefert die Liste der Dokumente auf dem Server.
        /// </summary>
        /// <returns>Liste der registrierten Dokumente.</returns>
        [OperationContract(Name = "GetDocumentList")]
        [FaultContract(typeof(FaultException))]
        List<CwlbDocumentHeader> GetDocumentList();

        /// <summary>
        /// Registriert ein neues Dokument auf dem Server.
        /// </summary>
        /// <param name="objDocumentHeader">Header des Dokments, das regsitriert werden soll.</param>
        [OperationContract(Name = "RegisterDocumnt")]
        [FaultContract(typeof(FaultException))]
        void RegisterDocument(CwlbDocumentHeader objDocumentHeader);

        /// <summary>
        /// Löscht ein Dokument auf dem Server.
        /// </summary>
        /// <param name="objDocumentHeader">Header des Dokuments, das gelöscht werden soll.</param>
        [OperationContract(Name = "RemoveDocument")]
        [FaultContract(typeof(FaultException))]
        void RemoveDocument(CwlbDocumentHeader objDocumentHeader);
    }
}
