﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.ServiceModel;
using System.Text;
using System.Threading.Tasks;

namespace WeroSoft.Samples.LearningWcfContracts
{
    /// <summary>
    /// Definiert den Vertrag für die Übertragung von Dateien.
    /// </summary>
    [ServiceContract(Name = "DocumentStream", Namespace = GwlbConstants.XmlNamespaceService)]
    public interface IwlbDocumentStream
    {
        /// <summary>
        /// Liefert eine definierte Datei.
        /// </summary>
        /// <param name="strName">Name der Datei, die übertragen werden soll.</param>
        /// <returns>Datenstrom der gesendeten Datei.</returns>
        [OperationContract(Name = "DownloadDocument")]
        [FaultContract(typeof(FaultException))]
        Stream DownloadDocument(string strName);

        /// <summary>
        /// Empfängt eine Datei von einem Client.
        /// </summary>
        /// <param name="streamDocument">Datenstrom der zu empfanfgenden Datei.</param>
        /// <returns>Identifikation der empfangenen Datei.</returns>
        [OperationContract(Name = "UploadDocument")]
        [FaultContract(typeof(FaultException))]
        string UploadDocument(Stream streamDocument);
    }
}
