﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="StartPage.aspx.cs" Inherits="WeroSoft.Samples.LearningWcfWeb.StartPage" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <script type="text/javascript" src="Scripts/jquery-1.6.2.js"></script>
    <script type="text/javascript">

        // Holt alle Daten im JSON-Format
        function GetDataJson() {
            $.ajax({
                type: "GET",
                url: "RestDemoService.svc/Json/",
                data: "{}",
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                success: function (data) {

                    var list = document.getElementById("itemCollection");
                    list.options.length = 0;

                    $.each(data, function (i, item) {
                        newEntry = new Option(item.StringValue, item.IntegerValue, false, true);
                        list.options[list.length] = newEntry;
                    });

                    list.selectedIndex = 0;

                },
                error: function (msg) {
                    alert(msg);
                }
            });
        }

        // Holt alle Daten eines bestimmten Tages
        function GetDataPerDayJson() {

            var year = document.getElementById("textYear").value;
            var month = document.getElementById("textMonth").value;
            var day = document.getElementById("textDay").value;

            $.ajax({
                type: "GET",
                url: "RestDemoService.svc/Json/" + year + "/" + month + "/" + day,
                data: "{}",
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                success: function (data) {

                    if (data == null) {
                        alert("Keine Daten mit diesen Suchangaben gefunden");
                        return;
                    }

                    var list = document.getElementById("itemCollection");
                    list.options.length = 0;
                    newEntry = new Option(data.StringValue, data.IntegerValue, false, true);
                    list.options[list.length] = newEntry;
                    list.selectedIndex = 0;
                },
                error: function (msg) {
                    alert("Error");
                }
            });
        }
    </script>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <input type="button" name="readAllJson" value="Daten lesen" onclick="GetDataJson()" />
        <br />
        <label for="textYear">Jahr:</label>
        <input type="text" id="textYear" value="2012" />
        <label for="textMonth">Monat:</label>
        <input type="text" id="textMonth" value="02" />
        <label for="textDay">Tag:</label>
        <input type="text" id="textDay" value="29" />
        <input type="button" name="readAllJson" value="Daten lesen" onclick="GetDataPerDayJson()" />
    </div>
    </form>

    <select id="itemCollection" multiple="multiple" style="height: 400px; width: 200px" />
</body>
</html>
