﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel.Description;
using System.ServiceModel.Dispatcher;
using System.ServiceModel.Channels;

namespace WeroSoft.Samples.LearningWcfClient
{
    /// <summary>
    /// Definiert das Verhaltensobjekt für die Nachrichtenprüfung.
    /// </summary>
    public class CwlbClientMessageBehavior<T> : IEndpointBehavior where T: IClientMessageInspector, new()
    {
        public void AddBindingParameters(ServiceEndpoint objEndpoint, BindingParameterCollection objBindingParameters)
        {
            // Diese Methode wird im Beispiel nicht benutzt und ist nur 
            // notwendig um die Schnittstellenimplementierung vorzunehmen
        }

        /// <summary>
        /// Erzeugt und verbindet die Nachrichtenprüfung
        /// </summary>
        /// <param name="objEndpoint">Der Endpunkt der kontrolliert wird.</param>
        /// <param name="objClientRuntime">Der Client der verändert wird.</param>
        public void ApplyClientBehavior(ServiceEndpoint objEndpoint, ClientRuntime objClientRuntime)
        {
            objClientRuntime.MessageInspectors.Add(new T());
        }

        public void ApplyDispatchBehavior(ServiceEndpoint objEndpoint, EndpointDispatcher objEndpointDispatcher)
        {
            // Diese Methode wird im Beispiel nicht benutzt und ist nur 
            // notwendig um die Schnittstellenimplementierung vorzunehmen
        }

        public void Validate(ServiceEndpoint objEndpoint)
        {
            // Diese Methode wird im Beispiel nicht benutzt und ist nur 
            // notwendig um die Schnittstellenimplementierung vorzunehmen
        }
    }
}
