﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel.Dispatcher;
using System.ServiceModel.Channels;
using System.Threading;
using System.Globalization;
using WeroSoft.Samples.LearningWcfContract;
using System.ServiceModel;

namespace WeroSoft.Samples.LearningWcfClient
{
    /// <summary>
    /// Implementiert den clientseitigen Nachrichtenprüfung.
    /// </summary>
    public class CwlbClientMessageInspector : IClientMessageInspector
    {
        /// <summary>
        /// Kontrolliert die Nachricht bevor sie an den Server gesendet wird.
        /// </summary>
        /// <param name="objRequest">Die Nachricht, die an den Dienst gesendet werden soll.</param>
        /// <param name="objChannel">.</param>
        /// <returns>
        /// Ein Objekt, das zur Korelation der Argumente nach dem Methodenaufruf AfterReceiveReply verwendet wird. Der Return dieser Methode
        /// ist null, wenn keine Korrelation verwendet werden soll.
        /// </returns>
        public object BeforeSendRequest(ref Message objRequest, IClientChannel objChannel)
        {
            // Schreibe die Thread-Sprache in den Nachrichten-Header
            objRequest.Headers.Add(MessageHeader.CreateHeader(
                GwlbConstants.MessageInspectionCulture,
                GwlbConstants.XmlNamespaceHeader, 
                Thread.CurrentThread.CurrentCulture.Name));

            // Schreibe die Thread-Ressourcen-Sprache in den Nachrichten-Header
            objRequest.Headers.Add(MessageHeader.CreateHeader(
                GwlbConstants.MessageInspectionUICulture,
                GwlbConstants.XmlNamespaceHeader, 
                Thread.CurrentThread.CurrentUICulture.Name));

            return null;
        }

        public void AfterReceiveReply(ref Message reply, object correlationState)
        {
            // Diese Methode wird im Beispiel nicht benutzt und ist nur 
            // notwendig um die Schnittstellenimplementierung vorzunehmen
        }
    }
}
