﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.ServiceModel.Description;
using System.Text;
using System.Threading.Tasks;
using WeroSoft.Samples.LearningWcfContract;

namespace WeroSoft.Samples.LearningWcfClient
{
    /// <summary>
    /// Rich-Client für die Demo.
    /// </summary>
    class CwlbRichClient : ClientBase<IwlbDemoService>, IwlbDemoService
    {
        /// <summary>
        /// Initialisiert eine neue Instanz eines Clients
        /// </summary>
        /// <param name="objBinding">Zu verwendende Bindung.</param>
        /// <param name="objAddress">Zu verwendende Addresse.</param>
        public CwlbRichClient(Binding objBinding, EndpointAddress objAddress)
            : base(objBinding, objAddress)
        {
            Endpoint.Behaviors.Add(new CwlbClientMessageBehavior<CwlbClientMessageInspector>());
        }

        /// <summary>
        /// Methode für die sprachspezifische Verarbeitung der Eingabe.
        /// </summary>
        /// <param name="dValue">Realzahl.</param>
        /// <param name="dtValue">Datum.</param>
        /// <returns>Serverseitig lokalisierter Text</returns>
        public string GetLanguageData(double dValue, DateTime dtValue)
        {
            return base.Channel.GetLanguageData(dValue, dtValue);
        }

        /// <summary>
        /// Testmethode für Inspektoren
        /// </summary>
        /// <param name="strParam1">Testparameter 1. Dieser Parameter darf nich null sein.</param>
        /// <param name="strParam2">Testparameter 2. Dieser Parameter darf nicht null sein.</param>
        /// <param name="iParam3">Testparameter 3. Dieser Parameter muss kleiner oder gleich als der Wert 42 sein.</param>
        /// <returns>Formatierter Resultattext.</returns>
        public string GetSpecialName(string strParam1, string strParam2, int iParam3)
        {
            return base.Channel.GetSpecialName(strParam1, strParam2, iParam3 );
        }

        /// <summary>
        /// Testmethode für Inspektoren.
        /// </summary>
        /// <param name="strParam1">Testparameter 1.</param>
        /// <param name="strParam2">Testparameter 2.</param>
        /// <param name="strParam3">Testparameter 3.</param>
        /// <param name="strParam4">Testparameter 4.</param>
        /// <param name="strParam5">Testparameter 5. Dieser Parameter darf nich null sein.</param>
        /// <param name="strParam6">Testparameter 6. Dieser Parameter darf nich null sein.</param>
        /// <param name="strParam7">Testparameter 7.</param>
        /// <param name="strParam8">Testparameter 8. Dieser Parameter darf nich null sein.</param>
        public void TestMethod(string strParam1, string strParam2, string strParam3, string strParam4, string strParam5, string strParam6, string strParam7, string strParam8)
        {
            base.Channel.TestMethod(strParam1, strParam2, strParam3, strParam4, strParam5, strParam6, strParam7, strParam8);
        }
    }
}
