﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.ServiceModel.Dispatcher;
using System.Text;
using System.Threading.Tasks;

namespace WeroSoft.Samples.LearningWcfContract
{
    /// <summary>
    /// Implementiert dei Nachrichtenprüfung für das Logging einer Nachricht.
    /// </summary>
    public sealed class CwlbLoggingMessageInspector : IClientMessageInspector, IDispatchMessageInspector
    {
        public void AfterReceiveReply(ref Message objReply, object objCorrelationState)
        {
            // Diese Methode wird im Beispiel nicht benutzt und ist nur 
            // notwendig um die Schnittstellenimplementierung vorzunehmen
        }

        public object BeforeSendRequest(ref Message objRequest, IClientChannel objChannel)
        {
            // Diese Methode wird im Beispiel nicht benutzt und ist nur 
            // notwendig um die Schnittstellenimplementierung vorzunehmen
            return null;
        }

        /// <summary>
        /// Prüft eine Nachricht, nachdem sie empfangen wurde. 
        /// </summary>
        /// <param name="objRequest">Anforderung an den Server.</param>
        /// <param name="objChannel">Kanal auf dem die Anforderung empfangen wurde.</param>
        /// <param name="objInstanceContext">Instanz mit der die Anforderung verarbeitet werden wird.</param>
        /// <returns>Korrelationsidentifikation, die verwendet werden soll oder null wenn keine Korrelation gebildet werden soll.</returns>
        public object AfterReceiveRequest(ref Message objRequest, IClientChannel objChannel, InstanceContext objInstanceContext)
        {
            string strServiceName = objInstanceContext.GetServiceInstance().GetType().Name;
            string strSession = objChannel.SessionId.ToString();
            string strListener = objChannel.LocalAddress.ToString();
            string strRequest = objRequest.Headers.Action.Substring(objRequest.Headers.Action.LastIndexOf('/') + 1);
            Console.WriteLine("{0}->{1}->{2}.{3}", strServiceName, strSession, strListener, strRequest);
            return null;
        }

        public void BeforeSendReply(ref Message objReply, object objCorrelationState)
        {
            // Diese Methode wird im Beispiel nicht benutzt und ist nur 
            // notwendig um die Schnittstellenimplementierung vorzunehmen
        }
    }
}
