﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel.Description;
using System.ServiceModel.Configuration;
using System.ServiceModel.Dispatcher;
using System.ServiceModel.Channels;

namespace WeroSoft.Samples.LearningWcfContract
{
    /// <summary>
    /// Definiert das Verhaltensobjekt für die Nachrichtenprüfung.
    /// </summary>
    public class CwlbServerMessageBehavior<T> : IEndpointBehavior where T : IDispatchMessageInspector, new()
    {
        public void AddBindingParameters(ServiceEndpoint objEndpoint, BindingParameterCollection objBindingParameters)
        {
            // Diese Methode wird im Beispiel nicht benutzt und ist nur 
            // notwendig um die Schnittstellenimplementierung vorzunehmen
        }

        public void ApplyClientBehavior(ServiceEndpoint objEndpoint, ClientRuntime clientRuntime)
        {
            // Diese Methode wird im Beispiel nicht benutzt und ist nur 
            // notwendig um die Schnittstellenimplementierung vorzunehmen
        }

        /// <summary>
        /// Erzeugt und verbindet die Nachrichtenprüfung.
        /// </summary>
        /// <param name="objEndpoint">Der Endpunkt der kontrolliert wird.</param>
        /// <param name="objEndpointDispatcher">Der Endpunkt-Dispatcher der verändert wird.</param>
        public void ApplyDispatchBehavior(ServiceEndpoint objEndpoint, EndpointDispatcher objEndpointDispatcher)
        {
            objEndpointDispatcher.DispatchRuntime.MessageInspectors.Add(new T());
        }

        public void Validate(ServiceEndpoint objEndpoint)
        {
            // Diese Methode wird im Beispiel nicht benutzt und ist nur 
            // notwendig um die Schnittstellenimplementierung vorzunehmen
        }
    }
}
