﻿ using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Text;
using System.Threading.Tasks;

namespace WeroSoft.Samples.LearningWcfContract
{
    /// <summary>
    /// Definiert die Schnittstelle des Demodienstes.
    /// </summary>
    [ServiceContract(Name = "DemoService", Namespace = GwlbConstants.XmlNamespaceService)]
    public interface IwlbDemoService
    {
        /// <summary>
        /// Methode für die sprachspezfische Verarbeitung der Eingabe.
        /// </summary>
        /// <param name="dValue">Realzahl.</param>
        /// <param name="dtValue">Datum.</param>
        /// <returns>Serverseitig lokalisierter Text</returns>
        [OperationContract(Name = "GetLanguageData")]
        string GetLanguageData(double dValue, DateTime dtValue);

        /// <summary>
        /// Testmethode für Inspektoren
        /// </summary>
        /// <param name="strParam1">Testparameter 1. Dieser Parameter darf nich null sein.</param>
        /// <param name="strParam2">Testparameter 2. Dieser Parameter darf nicht null sein.</param>
        /// <param name="iParam3">Testparameter 3. Dieser Parameter muss kleiner oder gleich als der Wert 42 sein.</param>
        /// <returns>Formatierter Resultattext.</returns>
        [AwlbParameterNotNull(new string[] { "strParam1", "strParam2" })]
        [FaultContract(typeof(CwlbDemoFault))]
        [OperationContract(Name = "DemoFault")]
        string GetSpecialName(string strParam1, string strParam2, int iParam3);

        /// <summary>
        /// Testmethode für Inspektoren.
        /// </summary>
        /// <param name="strParam1">Testparameter 1.</param>
        /// <param name="strParam2">Testparameter 2.</param>
        /// <param name="strParam3">Testparameter 3.</param>
        /// <param name="strParam4">Testparameter 4.</param>
        /// <param name="strParam5">Testparameter 5. Dieser Parameter darf nich null sein.</param>
        /// <param name="strParam6">Testparameter 6. Dieser Parameter darf nich null sein.</param>
        /// <param name="strParam7">Testparameter 7.</param>
        /// <param name="strParam8">Testparameter 8. Dieser Parameter darf nich null sein.</param>
        [AwlbParameterNotNull(new string[] { "strParam5", "strParam6", "strParam8" })]
        [OperationContract(Name = "TestMethod")]
        void TestMethod(string strParam1, string strParam2, string strParam3, string strParam4, string strParam5, string strParam6, string strParam7, string strParam8);
    }
}
