﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.ServiceModel.Dispatcher;
using System.Text;
using System.Threading.Tasks;
using WeroSoft.Samples.LearningWcfContract;
using WeroSoft.Samples.LearningWcfImplementation;

namespace WeroSoft.Samples.LearningWcfHost
{
    /// <summary>
    /// Implementiert den Server.
    /// </summary>
    class Program
    {
        /// <summary>
        /// Einstiegspunkt in die Anwendung.
        /// </summary>
        static void Main()
        {
            // Diensthost erzeugen
            using (ServiceHost objHost = new ServiceHost(typeof(CwlbDemoService)))
            {

                // Messageinspector registrieren
                objHost.Description.Endpoints[0].Behaviors.Add(new CwlbServerMessageBehavior<CwlbServerMessageInspector>());

                // Errorhandler registrieren
                object[] aobjAttributes = objHost.Description.ServiceType.GetCustomAttributes(false);
                foreach (AwlbServiceErrorHandlerAttribute objErrorHandler in aobjAttributes.OfType<AwlbServiceErrorHandlerAttribute>())
                {
                    foreach (ChannelDispatcher objDispatcher in objHost.ChannelDispatchers)
                    {
                        objDispatcher.ErrorHandlers.Add(objErrorHandler.Create());
                    }
                }

                // Host für den Betrieb bereitstellen
                objHost.Open();

                // Prozessraum am Leben erhalten
                Console.WriteLine("Dienst ist gestartet ...");
                Console.ReadKey(true);
            }
        }
    }
}
