﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.ServiceModel.Description;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using WeroSoft.Samples.LearningWcfContract;

namespace WeroSoft.Samples.LearningWcfImplementation
{
    /// <summary>
    /// Implementiert den Demodienst.
    /// </summary>
    [AwlbServiceErrorHandler(typeof(CwlbErrorHandler))]
    [ServiceBehavior(InstanceContextMode=InstanceContextMode.PerSession)]
    public class CwlbDemoService : IwlbDemoService
    {
        /// <summary>
        /// Methode für die sprachspezfische Verarbeitung der Eingabe.
        /// </summary>
        /// <param name="dValue">Realzahl.</param>
        /// <param name="dtValue">Datum.</param>
        /// <returns>Serverseitig lokalisierter Text</returns>
        public string GetLanguageData(double dValue, DateTime dtValue)
        {
            return string.Format(
                Properties.Resources.DataFormatString,     // Formatzeichenfolge
                dValue,                                    // Double-Wert
                dtValue,                                   // DateTime-Wert
                Thread.CurrentThread.CurrentCulture,       // Thread Regioneneinstellung für Formatierung
                Thread.CurrentThread.CurrentUICulture);    // Thread Regioneneinstellung für Ressourcen
        }

        /// <summary>
        /// Testmethode für Inspektoren
        /// </summary>
        /// <param name="strParam1">Testparameter 1. Dieser Parameter darf nich null sein.</param>
        /// <param name="strParam2">Testparameter 2. Dieser Parameter darf nicht null sein.</param>
        /// <param name="iParam3">Testparameter 3. Dieser Parameter muss kleiner oder gleich als der Wert 42 sein.</param>
        /// <returns>Formatierter Resultattext.</returns>
        public string GetSpecialName(string strParam1, string strParam2, int iParam3)
        {
            if (iParam3 > 42)
            {
                throw new InvalidOperationException("Sie sind über das Ziel hinaus geschossen.");
            }
            return string.Format("Die Differenz zur magischen Zahl 42 ist: {0}", 42 - iParam3);
        }

        /// <summary>
        /// Testmethode für Inspektoren.
        /// </summary>
        /// <param name="strParam1">Testparameter 1.</param>
        /// <param name="strParam2">Testparameter 2.</param>
        /// <param name="strParam3">Testparameter 3.</param>
        /// <param name="strParam4">Testparameter 4.</param>
        /// <param name="strParam5">Testparameter 5. Dieser Parameter darf nich null sein.</param>
        /// <param name="strParam6">Testparameter 6. Dieser Parameter darf nich null sein.</param>
        /// <param name="strParam7">Testparameter 7.</param>
        /// <param name="strParam8">Testparameter 8. Dieser Parameter darf nich null sein.</param>
        public void TestMethod(string strParam1, string strParam2, string strParam3, string strParam4, string strParam5, string strParam6, string strParam7, string strParam8)
        {
            Console.WriteLine("TestMethod wurde aufgerufen.");
            throw new ArgumentException("Diese Methode liefert immer einen Fehler.");
        }
    }
}
