﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel.Dispatcher;
using System.ServiceModel.Channels;
using System.Threading;
using System.Globalization;
using WeroSoft.Samples.LearningWcfContract;
using System.ServiceModel;

namespace WeroSoft.Samples.LearningWcfImplementation
{
    /// <summary>
    /// Implementiert die serverseitigen Nachrichtenprüfung.
    /// </summary>
    public class CwlbServerMessageInspector : IDispatchMessageInspector
    {
        /// <summary>
        /// Kontrolliert die Nachricht bevor sie an den Dienst gesendet wird.
        /// </summary>
        /// <param name="objRequest">Nachricht, die vom Client empfangen wurde.</param>
        /// <param name="objChannel">Kanal auf dem die nachricht empfangen wurde.</param>
        /// <returns>
        /// Ein Objekt, das zur Korelation der Argumene nach dem Methodenaufruf AfterReceiveReply verwendet wird. Der Return dieser Methode
        /// ist null, wenn keine Korealtion verwendet werden soll.
        /// </returns>
        public object AfterReceiveRequest(ref Message objRequest, IClientChannel objChannel, InstanceContext objInstanceContext)
        {
            // Einstellen der Basissprache für die Formatierung von Daten
            int index = objRequest.Headers.FindHeader(GwlbConstants.MessageInspectionCulture, GwlbConstants.XmlNamespaceHeader);
            if (index != -1)
            {
                Thread.CurrentThread.CurrentCulture = CultureInfo.CreateSpecificCulture(objRequest.Headers.GetHeader<string>(index));
            }
            else
            {
                Thread.CurrentThread.CurrentCulture = CultureInfo.InvariantCulture;
            }

            // Einstellen der Sprache für das Auflösen der Ressourcen
            index = objRequest.Headers.FindHeader(GwlbConstants.MessageInspectionUICulture, GwlbConstants.XmlNamespaceHeader);
            if (index != -1)
            {
                Thread.CurrentThread.CurrentUICulture = CultureInfo.CreateSpecificCulture(objRequest.Headers.GetHeader<string>(index));
            }
            else
            {
                Thread.CurrentThread.CurrentUICulture = CultureInfo.InvariantCulture;
            }

            return null;
        }

        public void BeforeSendReply(ref System.ServiceModel.Channels.Message reply, object correlationState)
        {
            // Diese Methode wird im Beispiel nicht benutzt und ist nur 
            // notwendig um die Schnittstellenimplementierung vorzunehmen
        }
    }
}
