﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using System.ServiceModel.MsmqIntegration;

namespace WeroSoft.Samples
{
    /// <summary>
    /// Implementiert den Service Host.
    /// </summary>
    class Program
    {
        /// <summary>
        /// Einsprungpunkt in das Programm.
        /// </summary>
        static void Main(string[] astrArguments)
        {
            // Definiert den Service Host.
            ServiceHost objHost = null;
            CwlbArgumentHelper objArgumentHelper = new CwlbArgumentHelper();
            objArgumentHelper.Parse(astrArguments);
            if (objArgumentHelper.Help)
            {
                objArgumentHelper.ShowHelp();
                return;
            }
            else
            {
                objArgumentHelper.ShowConfiguration();
            }

            try
            {
                // Erstellen des Diensthost für den Dienst CwlbDemoService
                objHost = new ServiceHost(typeof(CwlbDemoService));
                // Defineren eines Kommunikationsendpunktes
                objHost.AddServiceEndpoint(
                    typeof(IwlbDemoService),
                    objArgumentHelper.CreateBinding(), 
                    objArgumentHelper.CreateAddress());
                // Diensthost starten
                objHost.Open();
                // Verhindern das Prozess beendet wird.
                Console.WriteLine("Service Host ist gestartet. Mit einem Tastendruck kann er beendet werden ...");
                Console.ReadKey(true);
            }
            catch (Exception excObject)
            {
                // Ausnahmebehandlung
                Console.WriteLine(excObject.Message);
            }
            finally
            {
                // Beenden des Dienstes im Normalfall
                if (objHost != null && objHost.State == CommunicationState.Opened)
                {
                    objHost.Close();
                }
                // Beenden des Dienstes im Ausnahmefall
                if (objHost != null && objHost.State == CommunicationState.Faulted)
                {
                    objHost.Abort();
                }
            }
        }
    }
}
