﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;

namespace WeroSoft.Samples
{
    /// <summary>
    /// Definiert die Schnittstelle des Dienstes.
    /// </summary>
    [ServiceContract(Name="DemoService", Namespace = GwlbLearningWcf.XmlNamespaceService)]
    public interface IwlbDemoService
    {
        /// <summary>
        /// Liefert ein Array von Daten.
        /// </summary>
        /// <param name="demoData">Datenobjekt das als Vorlage vom Client an den Server gesendet wird.</param>
        /// <param name="iParam">Anzahl der zu generierenden Elemente in der Rückgabe. Dieser WErt darf nicht kleiner als 1 sein.</param>
        /// <returns>Array von serverseitig erzeugten Elementen.</returns>
        [OperationContract(Name="GetDemoData")]
        [FaultContract(typeof(CwlbFault))]
        CwlbDemoData[] GetDemoData(CwlbDemoData demoData, int iParam);
    }
}
