﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;

namespace WeroSoft.Samples
{
    /// <summary>
    /// Definiert die Schnittstelle des Dienstes.
    /// </summary>
    [ServiceContract(Name="DemoService", Namespace = GwlbLearningWcf.XmlNamespaceService)]
    public interface IwlbDemoService
    {
        /// <summary>
        /// Definiert eine Testmethode, die nur von Administratoren verwendet werden kann.
        /// </summary>
        /// <returns>Liefert eine Zeichenfolge, mit dem Methodennamen und weiteren Aufrufdaten.</returns>
        [OperationContract(Name = "MethodAdministration")]
        string MethodAdministration();

        /// <summary>
        /// Definiert eine Testmethode, die von Benutzern der Mitarbeitergruppe verwendet werden kann.
        /// </summary>
        /// <returns>Liefert eine Zeichenfolge, mit dem Methodennamen und weiteren Aufrufdaten.</returns>
        [OperationContract(Name = "MethodContributor")]
        string MethodContributor();

        /// <summary>
        /// Definiert eine Testmethode, die von Benutzern der Mitgliedergruppe verwendet werden kann.
        /// </summary>
        /// <returns>Liefert eine Zeichenfolge, mit dem Methodennamen und weiteren Aufrufdaten.</returns>
        [OperationContract(Name = "MethodMember")]
        string MethodMember();

        /// <summary>
        /// Definiert eine Testmethode, die von allen gültigen Benutzern verwendet werden kann.
        /// </summary>
        /// <returns>Liefert eine Zeichenfolge, mit dem Methodennamen und weiteren Aufrufdaten.</returns>
        [OperationContract(Name = "MethodAny")]
        string MethodAny();

        /// <summary>
        /// Demomethode für einen deklarativen Identitätswechsel.
        /// </summary>
        /// <returns>Liefert eine Zeichenfolge, mit dem Methodennamen und weiteren Aufrufdaten.</returns>
        [OperationContract(Name = "MethodImpersonatedDeclarative")]
        string MethodImpersonatedDeclarative();

        /// <summary>
        /// Demomethode für einen imperativen Identitätswechsel.
        /// </summary>
        /// <returns>Liefert eine Zeichenfolge, mit dem Methodennamen und weiteren Aufrufdaten.</returns>
        [OperationContract(Name = "MethodImpersonatedImperative")]
        string MethodImpersonatedImperative();
    }
}
