﻿using System;
using System.Collections.Generic;
using System.IdentityModel.Selectors;
using System.IdentityModel.Tokens;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WeroSoft.Samples
{
    /// <summary>
    /// Implementiert eine eigene Authentifizierung des Benutzers.
    /// </summary>
    public class CwlbCustomCredentialsValidator : UserNamePasswordValidator
    {
        /// <summary>
        /// Prüffunktion für die Authentifizierung der Benutzerangaben.
        /// </summary>
        /// <param name="strUserName">Name des Benutzers.</param>
        /// <param name="strPassword">Passwort des Benutzer.</param>
        public override void Validate(string strUserName, string strPassword)
        {
            // Hier verifizieren Sie die Angaben des Benutzer. Aus Gründen der 
            // Flexibilität werden die Daten dazu von außen veränderbar sein. Zum 
            // Beispiel in einer Datenbank oder in einer Datei. 

            if (string.Compare(strUserName, "testuser", true) == 0 &&
                string.Compare(strPassword, "password", false) == 0)
            {
                Console.WriteLine("Benutzer '{0}' erfolgreich authentifiziert.", strUserName);
                return;
            }
            else if (string.Compare(strUserName, "admin", true) == 0 &&
                string.Compare(strPassword, "adminPassword", false) == 0)
            {
                Console.WriteLine("Benutzer '{0}' erfolgreich authentifiziert.", strUserName);
                return;
            }
            else
            {
                Console.WriteLine("{0} Benutzer '{1}' NICHT erfolgreich authentifiziert.", 
                    DateTime.UtcNow.ToString("HH:mm:ss.fff"),
                    strUserName);
                throw new SecurityTokenValidationException("Ungültige Anmeldeinformationen");
            }
        }
    }
}
