﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel.Description;
using System.ServiceModel.Configuration;
using System.ServiceModel.Dispatcher;
using System.ServiceModel;
using System.Collections.ObjectModel;
using System.ServiceModel.Channels;

namespace WeroSoft.Samples
{
    /// <summary>
    /// Definiert das Verhaltensobjekt für den Messageinspector
    /// </summary>
    public class AwlbServiceErrorHandlerAttribute : Attribute, IServiceBehavior 
    {
        /// <summary>
        /// Typ des Fehlerhandler
        /// </summary>
        public Type ErrorHandlerType { get; private set; }

        public AwlbServiceErrorHandlerAttribute(Type objErrorHandlerType)
        {
            ErrorHandlerType = objErrorHandlerType;
        }

        public void AddBindingParameters(ServiceDescription serviceDescription, ServiceHostBase serviceHostBase, Collection<ServiceEndpoint> objEndpoints, BindingParameterCollection objBindingParameters)
        {
            // Diese Methode wird im Beispiel nicht benutzt und ist nur 
            // notwendig um die Schnittstellenimplementierung vorzunehmen
        }

        public void ApplyDispatchBehavior(ServiceDescription serviceDescription, System.ServiceModel.ServiceHostBase serviceHostBase)
        {
            foreach (ChannelDispatcher objDispatcher in serviceHostBase.ChannelDispatchers)
            {
                objDispatcher.ErrorHandlers.Add(new CwlbErrorHandler());
            }
        }

        public void Validate(ServiceDescription serviceDescription, System.ServiceModel.ServiceHostBase serviceHostBase)
        {
            // Diese Methode wird im Beispiel nicht benutzt und ist nur 
            // notwendig um die Schnittstellenimplementierung vorzunehmen
        }

        public IErrorHandler Create()
        {
            return Activator.CreateInstance(ErrorHandlerType) as IErrorHandler;
        }
    }
}
