﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WeroSoft.Samples.AssertLibrary
{
    /// <summary>
    /// Erweitert definierte Typen mit Prüfmethoden.
    /// </summary>
    public static class CwlbAssertExtensions
    {
        /// <summary>
        /// Prüft, ob ein short-Wert ungerade ist (mit Rest durch zwei teilbar).
        /// </summary>
        /// <param name="sValue">Wert der geprüft werden soll.</param>
        /// <param name="strMessage">Mitteilung für die Ausgabe im Fehlerfall.</param>
        /// <param name="aobjParams">Parameter für die Ausgabe im Fehlerfall.</param>
        public static void AssertIsOdd(this short sValue, string strMessage = null, params object[] aobjParams)
        {
            CwlbAssert.IsOdd(sValue, strMessage, aobjParams);
        }

        /// <summary>
        /// Prüft, ob ein int-Wert ungerade ist (mit Rest durch zwei teilbar).
        /// </summary>
        /// <param name="sValue">Wert der geprüft werden soll.</param>
        /// <param name="strMessage">Mitteilung für die Ausgabe im Fehlerfall.</param>
        /// <param name="aobjParams">Parameter für die Ausgabe im Fehlerfall.</param>
        public static void AssertIsOdd(this int iValue, string strMessage = null, params object[] aobjParams)
        {
            CwlbAssert.IsOdd(iValue, strMessage, aobjParams);
        }

        /// <summary>
        /// Prüft, ob ein long-Wert ungerade ist (mit Rest durch zwei teilbar).
        /// </summary>
        /// <param name="lValue">Wert der geprüft werden soll.</param>
        /// <param name="strMessage">Mitteilung für die Ausgabe im Fehlerfall.</param>
        /// <param name="aobjParams">Parameter für die Ausgabe im Fehlerfall.</param>
        public static void AssertIsOdd(this long lValue, string strMessage = null, params object[] aobjParams)
        {
            CwlbAssert.IsOdd(lValue, strMessage, aobjParams);
        }

        /// <summary>
        /// Prüft, ob ein short-Wert gerade ist (ohne Rest durch zwei teilbar).
        /// </summary>
        /// <param name="sValue">Wert der geprüft werden soll.</param>
        /// <param name="strMessage">Mitteilung für die Ausgabe im Fehlerfall.</param>
        /// <param name="aobjParams">Parameter für die Ausgabe im Fehlerfall.</param>
        public static void AssertIsEven(this short sValue, string strMessage = null, params object[] aobjParams)
        {
            CwlbAssert.IsEven(sValue, strMessage, aobjParams);
        }

        /// <summary>
        /// Prüft, ob ein int-Wert gerade ist (ohne Rest durch zwei teilbar).
        /// </summary>
        /// <param name="sValue">Wert der geprüft werden soll.</param>
        /// <param name="strMessage">Mitteilung für die Ausgabe im Fehlerfall.</param>
        /// <param name="aobjParams">Parameter für die Ausgabe im Fehlerfall.</param>
        public static void AssertIsEven(this int iValue, string strMessage = null, params object[] aobjParams)
        {
            CwlbAssert.IsEven(iValue, strMessage, aobjParams);
        }

        /// <summary>
        /// Prüft, ob ein long-Wert gerade ist (ohne Rest durch zwei teilbar).
        /// </summary>
        /// <param name="lValue">Wert der geprüft werden soll.</param>
        /// <param name="strMessage">Mitteilung für die Ausgabe im Fehlerfall.</param>
        /// <param name="aobjParams">Parameter für die Ausgabe im Fehlerfall.</param>
        public static void AssertIsEven(this long lValue, string strMessage = null, params object[] aobjParams)
        {
            CwlbAssert.IsEven(lValue, strMessage, aobjParams);
        }

    }
}
