﻿using System;
using System.Text;
using System.Collections.Generic;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using WeroSoft.Samples.AssertLibrary;

namespace WeroSoft.Samples.LearningUnitTest.Test
{
    /// <summary>
    /// Summary description for AssertLibraryTest
    /// </summary>
    [TestClass]
    public class CwlbAssertLibraryTest
    {
        /// <summary>
        /// Prüft die eigene Prüfklasse auf ungerade oder gerade Zahlen.
        /// </summary>
        [TestMethod]
        public void OwnAssertTest()
        {
            // ----------------------------------------------------------------
            // Positive Tests
            // ----------------------------------------------------------------
            short sValueOdd = 5;
            short sValueEven = 6;
            int iValueOdd = 5;
            int iValueEven = 6;
            long lValueOdd = 5;
            long lValueEven = 6;

            CwlbAssert.IsOdd(sValueOdd);
            CwlbAssert.IsOdd(sValueOdd, "Der Wert der Variablen '{0}' repräsentiert eine gerade Zahl.", "sValueOdd");
            CwlbAssert.IsEven(sValueEven);
            CwlbAssert.IsEven(sValueEven, "Der Wert der Variablen '{0}' repräsentiert eine ungerade Zahl.", "sValueEven");

            CwlbAssert.IsOdd(iValueOdd);
            CwlbAssert.IsOdd(iValueOdd, "Der Wert der Variablen '{0}' repräsentiert eine gerade Zahl.", "iValueOdd");
            CwlbAssert.IsEven(iValueEven);
            CwlbAssert.IsEven(iValueEven, "Der Wert der Variablen '{0}' repräsentiert eine ungerade Zahl.", "iValueEven");

            CwlbAssert.IsOdd(lValueOdd);
            CwlbAssert.IsOdd(lValueOdd, "Der Wert der Variablen '{0}' repräsentiert eine gerade Zahl.", "lValueOdd");
            CwlbAssert.IsEven(lValueEven);
            CwlbAssert.IsEven(lValueEven, "Der Wert der Variablen '{0}' repräsentiert eine ungerade Zahl.", "lValueEven");

            // ----------------------------------------------------------------
            // Negative Tests
            // ----------------------------------------------------------------
            sValueOdd = 6;
            sValueEven = 5;
            iValueOdd = 6;
            iValueEven = 5;
            lValueOdd = 6;
            lValueEven = 5;

            AssertIsOddNegativetest<short>(CwlbAssert.IsOdd, sValueOdd);
            AssertIsOddNegativetest<short>(CwlbAssert.IsOdd, sValueOdd,
                "Der Wert der Variablen '{0}' repräsentiert eine gerade Zahl.", "sValueOdd");
            AssertIsOddNegativetest<short>(CwlbAssert.IsEven, sValueEven);
            AssertIsOddNegativetest<short>(CwlbAssert.IsEven, sValueEven,
                "Der Wert der Variablen '{0}' repräsentiert eine ungerade Zahl.", "sValueEven");

            AssertIsOddNegativetest<int>(CwlbAssert.IsOdd, iValueOdd);
            AssertIsOddNegativetest<int>(CwlbAssert.IsOdd, iValueOdd,
                "Der Wert der Variablen '{0}' repräsentiert eine gerade Zahl.", "iValueOdd");
            AssertIsOddNegativetest<int>(CwlbAssert.IsEven, iValueEven);
            AssertIsOddNegativetest<int>(CwlbAssert.IsEven, iValueEven,
                "Der Wert der Variablen '{0}' repräsentiert eine ungerade Zahl.", "iValueEven");

            AssertIsOddNegativetest<long>(CwlbAssert.IsOdd, lValueOdd);
            AssertIsOddNegativetest<long>(CwlbAssert.IsOdd, lValueOdd,
                "Der Wert der Variablen '{0}' repräsentiert eine gerade Zahl.", "lValueOdd");
            AssertIsOddNegativetest<long>(CwlbAssert.IsEven, lValueEven);
            AssertIsOddNegativetest<long>(CwlbAssert.IsEven, lValueEven,
                "Der Wert der Variablen '{0}' repräsentiert eine ungerade Zahl.", "lValueEven");
        }

        /// <summary>
        /// Prüft die eigene Prüfklasse auf ungerade oder gerade Zahlen.
        /// </summary>
        [TestMethod]
        public void OwnAssertExtensionTest()
        {
            // ----------------------------------------------------------------
            // Positive Tests
            // ----------------------------------------------------------------
            short sValueOdd = 5;
            short sValueEven = 6;
            int iValueOdd = 5;
            int iValueEven = 6;
            long lValueOdd = 5;
            long lValueEven = 6;

            sValueOdd.AssertIsOdd();
            sValueOdd.AssertIsOdd("Der Wert der Variablen '{0}' repräsentiert eine gerade Zahl.", "sValueOdd");
            sValueEven.AssertIsEven();
            sValueEven.AssertIsEven("Der Wert der Variablen '{0}' repräsentiert eine ungerade Zahl.", "sValueEven");

            iValueOdd.AssertIsOdd();
            iValueOdd.AssertIsOdd("Der Wert der Variablen '{0}' repräsentiert eine gerade Zahl.", "iValueOdd");
            iValueEven.AssertIsEven();
            iValueEven.AssertIsEven("Der Wert der Variablen '{0}' repräsentiert eine ungerade Zahl.", "iValueEven");

            lValueOdd.AssertIsOdd();
            lValueOdd.AssertIsOdd("Der Wert der Variablen '{0}' repräsentiert eine gerade Zahl.", "lValueOdd");
            lValueEven.AssertIsEven();
            lValueEven.AssertIsEven("Der Wert der Variablen '{0}' repräsentiert eine ungerade Zahl.", "lValueEven");

            // ----------------------------------------------------------------
            // Negative Tests
            // ----------------------------------------------------------------
            sValueOdd = 6;
            sValueEven = 5;
            iValueOdd = 6;
            iValueEven = 5;
            lValueOdd = 6;
            lValueEven = 5;

            AssertIsOddNegativetest<short>(CwlbAssertExtensions.AssertIsOdd, sValueOdd);
            AssertIsOddNegativetest<short>(CwlbAssertExtensions.AssertIsOdd, sValueOdd, "Der Wert der Variablen '{0}' repräsentiert eine gerade Zahl.", "sValueOdd");
            AssertIsOddNegativetest<short>(CwlbAssertExtensions.AssertIsEven, sValueEven);
            AssertIsOddNegativetest<short>(CwlbAssertExtensions.AssertIsEven, sValueEven, "Der Wert der Variablen '{0}' repräsentiert eine ungerade Zahl.", "sValueEven");

            AssertIsOddNegativetest<int>(CwlbAssertExtensions.AssertIsOdd, iValueOdd);
            AssertIsOddNegativetest<int>(CwlbAssertExtensions.AssertIsOdd, iValueOdd, "Der Wert der Variablen '{0}' repräsentiert eine gerade Zahl.", "iValueOdd");
            AssertIsOddNegativetest<int>(CwlbAssertExtensions.AssertIsEven, iValueEven);
            AssertIsOddNegativetest<int>(CwlbAssertExtensions.AssertIsEven, iValueEven, "Der Wert der Variablen '{0}' repräsentiert eine ungerade Zahl.", "iValueEven");

            AssertIsOddNegativetest<long>(CwlbAssertExtensions.AssertIsOdd, lValueOdd);
            AssertIsOddNegativetest<long>(CwlbAssertExtensions.AssertIsOdd, lValueOdd, "Der Wert der Variablen '{0}' repräsentiert eine gerade Zahl.", "lValueOdd");
            AssertIsOddNegativetest<long>(CwlbAssertExtensions.AssertIsEven, lValueEven);
            AssertIsOddNegativetest<long>(CwlbAssertExtensions.AssertIsEven, lValueEven, "Der Wert der Variablen '{0}' repräsentiert eine ungerade Zahl.", "lValueEven");
        }

        /// <summary>
        /// Führt einen Negativtest durch und überprüft die erwartet Ausnahme.
        /// </summary>
        /// <typeparam name="T">Typ für den die Methode benutzt wird.</typeparam>
        /// <param name="objMethod">Delegate der eigentlich aufzurufenden Prüfmethode.</param>
        /// <param name="objValue">Zu überprüfender Wert.</param>
        /// <param name="strMessage">Mitteilung für die Ausgabe im Fehlerfall.</param>
        /// <param name="aobjParams">Parameter für die Ausgabe im Fehlerfall.</param>
        private void AssertIsOddNegativetest<T>(Action<T, string, object[]> objMethod, T objValue, string strMessage = null, params object[] aobjParams)
        {
            bool bExpectedException = false;

            try
            {
                objMethod(objValue, strMessage, aobjParams);
            }
            catch (AssertFailedException)
            {
                // Diese Ausnahme wurde erwartet, richtiger Ausgang.
                bExpectedException = true;
            }
            finally
            {
                if (!bExpectedException)
                {
                    Assert.Fail("Bei der Prüfung wurde nicht die erwartete Ausnahme ausgelöst");
                }
            }
        }
    }
}
