﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace WeroSoft.Samples.LearningUnitTest.Test
{
    /// <summary>
    /// Definiert eine Testklasse für die Demonstration von Kategorien und Prioritäten.
    /// </summary>
    [TestClass]
    public class CwlbCategorizedTestsB
    {
        /// <summary>
        /// Liefert oder definiert den Testkontext.
        /// </summary>
        public TestContext TestContext { get; set; }

        /// <summary>
        /// Definiert einen Test der Kategorie Checkin.
        /// </summary>
        [TestCategory(CwlbAssemblyLevelHandling.CategoryCheckinTest)]
        [Priority(CwlbAssemblyLevelHandling.High)]
        [TestMethod]
        public void TestBCheckinHigh()
        {
            CwlbAssemblyLevelHandling.WriteLog(TestContext, "{0}", MethodInfo.GetCurrentMethod());
        }

        /// <summary>
        /// Definiert einen Test der Kategorie Checkin.
        /// </summary>
        [TestCategory(CwlbAssemblyLevelHandling.CategoryCheckinTest)]
        [Priority(CwlbAssemblyLevelHandling.Low)]
        [TestMethod]
        public void TestBCheckinLow()
        {
            CwlbAssemblyLevelHandling.WriteLog(TestContext, "{0}", MethodInfo.GetCurrentMethod());
        }

        /// <summary>
        /// Definiert einen Test der Kategorie Checkin.
        /// </summary>
        [TestCategory(CwlbAssemblyLevelHandling.CategoryIterationTest)]
        [Priority(CwlbAssemblyLevelHandling.High)]
        [TestMethod]
        public void TestBIterationHigh()
        {
            CwlbAssemblyLevelHandling.WriteLog(TestContext, "{0}", MethodInfo.GetCurrentMethod());
        }

        /// <summary>
        /// Definiert einen Test der Kategorie Checkin.
        /// </summary>
        [TestCategory(CwlbAssemblyLevelHandling.CategoryIterationTest)]
        [Priority(CwlbAssemblyLevelHandling.Low)]
        [TestMethod]
        public void TestBterationLow()
        {
            CwlbAssemblyLevelHandling.WriteLog(TestContext, "{0}", MethodInfo.GetCurrentMethod());
        }

        /// <summary>
        /// Definiert einen Test der Kategorie Checkin.
        /// </summary>
        [TestCategory(CwlbAssemblyLevelHandling.CategoryProductTest)]
        [Priority(CwlbAssemblyLevelHandling.High)]
        [TestMethod]
        public void TestBProductHigh()
        {
            CwlbAssemblyLevelHandling.WriteLog(TestContext, "{0}", MethodInfo.GetCurrentMethod());
        }

        /// <summary>
        /// Definiert einen Test der Kategorie Checkin.
        /// </summary>
        [TestCategory(CwlbAssemblyLevelHandling.CategoryProductTest)]
        [Priority(CwlbAssemblyLevelHandling.Low)]
        [TestMethod]
        public void TestBProductLow()
        {
            CwlbAssemblyLevelHandling.WriteLog(TestContext, "{0}", MethodInfo.GetCurrentMethod());
        }

        /// <summary>
        /// Definiert einen Test der Kategorie Checkin.
        /// </summary>
        [TestCategory(CwlbAssemblyLevelHandling.CategoryCheckinTest)]
        [TestCategory(CwlbAssemblyLevelHandling.CategoryIterationTest)]
        [TestCategory(CwlbAssemblyLevelHandling.CategoryProductTest)]
        [Priority(CwlbAssemblyLevelHandling.Low)]
        [TestMethod]
        public void TestBAllCategoriesLow()
        {
            CwlbAssemblyLevelHandling.WriteLog(TestContext, "{0}", MethodInfo.GetCurrentMethod());
        }
    }
}
