﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace WeroSoft.Samples.LearningUnitTest.Test
{
    /// <summary>
    /// Tested die Klasse CwlbSystemTest.
    /// </summary>
    [TestClass]
    public class CwlbSystemInfoTest
    {
        /// <summary>
        /// Test für die Methode CreateSystemInfo.
        /// </summary>
        [TestMethod]
        public void CreateMachineInfoTest()
        {
            // Bereitstellen des erwarteten Resultats
            CwlbMachineInfo objExpectedMachineInfo = new CwlbMachineInfo();
            objExpectedMachineInfo.Name = Environment.MachineName;
            objExpectedMachineInfo.OsVersion = Environment.OSVersion;
            objExpectedMachineInfo.ClrVersion = Environment.Version;

            // Durchführen des Tests
            CwlbMachineInfo objResultingMachineInfo = CwlbSystemInfo.CreateMachineInfo();

            // Resultat überprüfen
            Assert.IsNotNull(objResultingMachineInfo, "Das gelieferte Resultat darf nicht null sein.");
            Assert.AreEqual<string>(
                objExpectedMachineInfo.Name,
                objResultingMachineInfo.Name,
                "Der Name der Maschine ist nicht korrekt");
            Assert.AreEqual<OperatingSystem>(
                objExpectedMachineInfo.OsVersion,
                objResultingMachineInfo.OsVersion,
                "Die Betriebssystemversion ist nicht korrekt");
            Assert.AreEqual<Version>(
                objExpectedMachineInfo.ClrVersion,
                objResultingMachineInfo.ClrVersion,
                "Die CLR-Version ist nicht korrekt");
        }
    }
}
